#pragma once
#ifndef __HEADER___GUI_APPLI_OBJECT_CONTOURING__
#define __HEADER___GUI_APPLI_OBJECT_CONTOURING__

#include"gl_widget.h"

struct gui_rendering_empty_sample
{

	static std::vector<std::pair<std::string, double*>> link_double_spinbox_in_gui;
	static std::vector<std::pair<std::string, int*>> link_int_spinbox_in_gui;

	static std::vector<std::string> extra_alpha_parameter;

	template<typename Triangulation>
	static std::vector<float*> ini_vbo_get_alpha(Triangulation& triangulation, gl_widget* gl_wgt, VBO& vbo_to_put_vertices, const std::string& obj_name, const float depth, const glm::vec3& color_nodes, const std::vector<glm::vec3>& color_edges)
	{
		const int img_cols = gl_wgt->img_cols;
		const int img_rows = gl_wgt->img_rows;
		std::vector<glm::vec2> vec_data_deg1;
		std::vector<int> color_edge;

		vec_data_deg1.reserve((triangulation.number_of_faces() + 1 + triangulation.number_of_vertices() - 2) * 2);
		color_edge.reserve((triangulation.number_of_faces() + 1 + triangulation.number_of_vertices() - 2) * 2);
		
		for (auto it(triangulation.finite_edges_begin()), it_end(triangulation.finite_edges_end()); it != it_end; ++it)
		{
			const auto& face = *it->first;
			const int& idx = it->second;
			const auto& p1 = face.vertex((idx + 1) % 3)->point();
			const auto& p2 = face.vertex((idx + 2) % 3)->point();
			vec_data_deg1.emplace_back(p1.x() / img_cols, p1.y() / img_rows);
			vec_data_deg1.emplace_back(p2.x() / img_cols, p2.y() / img_rows);

			if (triangulation.face_data[it->first->info()].label
				== triangulation.face_data[it->first->neighbor(it->second)->info()].label)
				color_edge.emplace_back(0);
			else
				color_edge.emplace_back(1);
			color_edge.emplace_back(color_edge.back());
		}
		vbo_to_put_vertices.clear_vbo();
		vbo_to_put_vertices.add_vertex(obj_name + "_1", vec_data_deg1);
		vbo_to_put_vertices.add_vertex(obj_name + "_1_c", color_edge);
		vbo_to_put_vertices.create_vbo();

		gl_bezier_deg_color_1* edges = gl_wgt->ini_bezier_deg_color<gl_bezier_deg_color_1>(obj_name + "_1", vbo_to_put_vertices, depth, color_edges, vec_data_deg1.size());
		edges->line_width = 1.0f;
		return std::vector<float*>{&edges->alpha};
	}
};
#endif  __HEADER___GUI_APPLI_OBJECT_CONTOURING__

