//  #version 330
//  
//  layout(points) in;
//  layout (triangle_strip, max_vertices=4) out;
//  
//  in vec3 color[1];
//  
//  out VertexData {
//  	vec3 color;
//  } VertexOut;
//  
//  void main(void)
//  {
//  	VertexOut.color = color[0];
//  	gl_Position = gl_in[0].gl_Position;
//  	gl_Position.y += 0.01f;
//  	gl_Position.x += 0.01f;
//  	EmitVertex();
//  	VertexOut.color = color[0];
//  	gl_Position = gl_in[0].gl_Position;
//  	gl_Position.y -= 0.01f;
//  	gl_Position.x += 0.01f;
//  	 EmitVertex();
//  	VertexOut.color = color[0];
//  	gl_Position = gl_in[0].gl_Position;
//  	gl_Position.y += 0.01f;
//  	gl_Position.x -= 0.01f;
//  	 EmitVertex();
//  	VertexOut.color = color[0];
//  	gl_Position = gl_in[0].gl_Position;
//  	gl_Position.y -= 0.01f;
//  	gl_Position.x -= 0.01f;
//  	 EmitVertex();
//      EndPrimitive();
//  }
//  
//  

#version 330

layout(points) in;
//layout (triangle_strip, max_vertices=32) out;
layout (triangle_strip, max_vertices=128) out;

//const float dtheta = 3.14159265359/16.0f;
const float dtheta = 3.14159265359/64.0f;

uniform float radius_of_point;
uniform float ratio;

#define coeff_mul 0.007
void main(void)
{
	gl_Position = gl_in[0].gl_Position;
	gl_Position.y += 0.0f;
	gl_Position.x += radius_of_point;
	EmitVertex();
	for(float i=dtheta; i<3.14159265359; i+=dtheta)
	{
		gl_Position = gl_in[0].gl_Position;
		gl_Position.xy+=vec2(cos(i),sin(i)*ratio)*radius_of_point;
		EmitVertex();
		gl_Position = gl_in[0].gl_Position;
		gl_Position.xy+=vec2(cos(-i),sin(-i)*ratio)*radius_of_point;
		EmitVertex();
	}
	gl_Position = gl_in[0].gl_Position;
	gl_Position.y -= 0.0f;
	//gl_Position.x -= 0.01f;
	gl_Position.x -= coeff_mul;
	EmitVertex();
	
    EndPrimitive();
}


