#pragma once
#ifndef __HEADER___THREAD__ALGO__
#define __HEADER___THREAD__ALGO__

#include<vector>
#include<thread>
#include<atomic>
#include"gl_widget.h"

template<typename SA>
class thread_algo
{
	std::vector<std::thread> some_thread;
	SA* sa;
	gl_widget* gl_wgt;
	std::atomic<bool> continue_thread;
	//bool continue_thread;
	void next_step()
	{
		while (sa->nb_it < sa->param.number_of_maximum_iteration)
		{
			std::clock_t t = clock();
			int k = 0;
			//std::cout << "thread id: " << std::this_thread::get_id() << " next_step" << std::endl;
			while(continue_thread && ((float)(clock() - t) / CLOCKS_PER_SEC < 1.00))
		//	for (int i = 0; i < 1000 && continue_thread; ++i)
			{
				sa->one_step();
				//sa->energy_iter.emplace_back(sa->current_energy);
				if(sa->nb_it%100==0)
					sa->energy_iter.emplace_back(sa->triangulation.get_energy());
				++sa->nb_it;
				++k;
			}
			std::cout << std::endl << k << "  " << clock() - t << std::endl;
			t = clock();
			//std::cout << "thread id: " << std::this_thread::get_id() << " next_step_end" << std::endl;
			if (continue_thread)
				emit gl_wgt->job_end();
			else
				break;
			std::cout << std::endl <<"GPU  "  << clock() - t << std::endl;
			
		}
		end_reach = true;
		if(sa->nb_it >= sa->param.number_of_maximum_iteration)
			emit gl_wgt->job_end_finish();
//		gl_wgt->update();
	}
public:
	std::atomic<bool> end_reach;
	thread_algo() :continue_thread(false), end_reach(false){}
	void launch(SA& _sa, gl_widget* _gl_wgt)
	{
		end_reach = false;
		continue_thread = true;
		sa = &_sa;
		gl_wgt = _gl_wgt;
		sa->current_energy = sa->triangulation.get_energy();
		some_thread.emplace_back(&thread_algo::next_step, this);// , &this->data_create_graph_from_file);
	}
	void stop()
	{
		continue_thread = false;
	//	std::cout << "thread id: " << std::this_thread::get_id() << " stop" << std::endl;
		for (auto& a : some_thread)
			a.join();
		some_thread.clear();
	//	std::cout << "thread id: " << std::this_thread::get_id() << " stop end" << std::endl;
	}

};


#endif //__HEADER___THREAD__ALGO__

