#pragma once
#ifndef __HEADER_DATA_STRUCTURE__
#define __HEADER_DATA_STRUCTURE__
#include"util_for_cgal.h"
#include"bernstein.h"

struct Ma_face
{
	__m128 id_face;
	Ma_face(int i, int j, int k)
	{
		if (i > j)
		{
			if (k < j)//i<j
			{
				((int*)&id_face)[0] = k;
				((int*)&id_face)[1] = j;
				((int*)&id_face)[2] = i;
				((int*)&id_face)[3] = 0;
			}
			else if (k > i)
			{
				((int*)&id_face)[0] = j;
				((int*)&id_face)[1] = i;
				((int*)&id_face)[2] = k;
				((int*)&id_face)[3] = 0;
			}
			else
			{
				((int*)&id_face)[0] = j;
				((int*)&id_face)[1] = k;
				((int*)&id_face)[2] = i;
				((int*)&id_face)[3] = 0;
			}
		}
		else if (k < i)//i<j
		{
			((int*)&id_face)[0] = k;
			((int*)&id_face)[1] = i;
			((int*)&id_face)[2] = j;
			((int*)&id_face)[3] = 0;
		}
		else if(k > j)
		{
			((int*)&id_face)[0] = i;
			((int*)&id_face)[1] = j;
			((int*)&id_face)[2] = k;
			((int*)&id_face)[3] = 0;
		}
		else
		{
			((int*)&id_face)[0] = i;
			((int*)&id_face)[1] = k;
			((int*)&id_face)[2] = j;
			((int*)&id_face)[3] = 0;
		}
	}
	operator __m128&() { return id_face; }
	operator const __m128&()const { return id_face; }
	bool operator<(const Ma_face& f)const
	{
		//return id_face < f.id_face;
		return (((__int64*)&id_face)[0] < ((__int64*)&f.id_face)[0]) || (((__int64*)&id_face)[0] == ((__int64*)&f.id_face)[0] && ((__int32*)&id_face)[2] < ((__int32*)&f.id_face)[2]);
	}
	//friend bool operator<(const Ma_face& f1, const Ma_face& f2)
	//{
	//	//return id_face < f.id_face;
	//	return (((__int64*)&f1.id_face)[0] < ((__int64*)&f2.id_face)[0]) || (((__int64*)&f1.id_face)[0] == ((__int64*)&f2.id_face)[0] && ((__int32*)&f1.id_face)[2] < ((__int32*)&f2.id_face)[2]);
	//}
};
struct Next_info
{
	std::list<int> removed_vertices;
	std::list<int> removed_faces;
	int next_vertex;
	int next_face;
	Next_info() :next_vertex(0), next_face(0) {}
	void reset()
	{
		removed_faces.clear();
		removed_vertices.clear();
		next_vertex = 0;
		next_face = 0;
	}
	int vertex()
	{
		if (removed_vertices.empty())
			return next_vertex++;
		const int i = removed_vertices.front();
		removed_vertices.erase(removed_vertices.begin());
		return i;
	}
	int face()
	{
		if (removed_faces.empty())
			return next_face++;
		const int i = removed_faces.front();
		removed_faces.erase(removed_faces.begin());
		return i;
	}
}next_info;
template<typename _label>
struct data
{
	typedef _label Label;
	//std::pair<int, float> label;
	Label label;//given by sa
	float p_label;
	float energy;
	std::set<int> set_of_curve;
	//glm::vec3 color;
};
template<typename Triangulation>
struct curve
{
	std::map<Mon_edge, std::pair<typename Triangulation::Point, typename Triangulation::Point>> set_of_edge;
	std::vector<std::pair<glm::vec2, double>> parametrization;
	glm::vec2 p1;//control point on the extremity of the curve
	glm::vec2 p2;
	glm::vec2 ctp1;//tangent control point this one active iff deg >= 2
	glm::vec2 ctp2;//this one active iff deg >= 3
	int type;
	template<typename Triangulation>
	void recompute_parametrization(Triangulation& t)
	{
		parametrization.clear();
		if (set_of_edge.size() == 0) 
		{
			p1.x = 0.0f;
			p1.y = 0.0f;
			p2.x = 0.0f;
			p2.y = 0.0f;
			type = 0;
			return;
		}
		if (set_of_edge.size() == 1)
		{
			typename Triangulation::Point pt = set_of_edge.begin()->second.first;
			p1.x = pt.x();
			p1.y = pt.y();
			pt = set_of_edge.begin()->second.second;
			p2.x = pt.x();
			p2.y = pt.y();
			return;
		}
		typename Triangulation::Point pt = set_of_edge.begin()->second.first;
		glm::vec2 tmp1(pt.x(), pt.y()), tmp;
		double dst = 0;
		std::set<typename Triangulation::Point> set_vert;
		for (const auto& pair : set_of_edge)
		{
			const std::pair<typename Triangulation::Point, typename Triangulation::Point>& me = pair.second;
			set_vert.emplace(me.first);
			set_vert.emplace(me.second);
			glm::vec2 tp1(me.first.x(), me.first.y());
			glm::vec2 tp2(me.second.x(), me.second.y());
			const int length = (int)(floor(glm::length(tp2 - tp1)));
			glm::vec2 pp;
			for (int i = 1; i < length - 1; ++i)
			{
				float tmp = i * 1.0 / length;
				pp = tp1 * tmp + tp2 * (1.0f - tmp);
				set_vert.emplace(typename Triangulation::Point(pp.x, pp.y));
			}
			pp = tp1 * 0.5f + tp2 * 0.5f;//for little edge
			set_vert.emplace(typename Triangulation::Point(pp.x, pp.y));
		}
		for (const typename Triangulation::Point pt : set_vert)
		{
			tmp = glm::vec2(pt.x(), pt.y());
			if (glm::distance2(tmp, tmp1) > dst)
			{
				dst = glm::distance2(tmp, tmp1);
				p1 = tmp;
			}
		}
		dst = 0;
		for (const typename Triangulation::Point pt : set_vert)
		{
			tmp = glm::vec2(pt.x(), pt.y());
			if (glm::distance2(tmp, p1) > dst)
			{
				dst = glm::distance2(tmp, p1);
				p2 = tmp;
			}
		}
		//here p1 and p2 are approximatively the two farest point
		//now fill parametrization;
		if (p1 == p2)
			return;
		float inv_len = 1.0 / glm::length(p2 - p1);
		glm::vec2 dir = (p2 - p1)*inv_len;
		for (const typename Triangulation::Point pt : set_vert)
		{
			tmp = glm::vec2(pt.x(), pt.y());
			parametrization.emplace_back(tmp, glm::dot(dir, tmp - p1)*inv_len);
		}
	}

	//glm::dvec2 bezier_pt(const std::size_t& degree, glm::dvec2 const V[], double const t)
	//{
	//	const int size = (int)degree;
	//	std::vector<double> b(size + 1);
	//	bernstein_polynome<>(t, b, size);
	//	glm::dvec2 pos;
	//	for (int i = 0; i < size + 1; ++i)
	//	{
	//		pos += V[i] * b[i];
	//	}
	//	return pos;
	//}
	//glm::dvec2 bezier_normal(const std::vector<glm::dvec2>& ctrl_point, const float& t)
	//{
	//	//const float& t2 = t*t;
	//	const int size = (int)ctrl_point.size() - 1;
	//	std::vector<double> d(size + 1);
	//	bernstein_grad(t, d, size);
	//	glm::dvec2 grad;
	//	for (int i = 0; i < size + 1; ++i)
	//	{
	//		grad += ctrl_point[i] * d[i];
	//	}
	//	return grad;
	//}
	template<typename Triangulation>
	void fit_curve(Triangulation& t)
	{
		//		recompute_farest_vertices(t);
		recompute_parametrization(t);
		type = (int)set_of_edge.size();
		if (type > 3)
			type = 3;

	//	type = 1;
	//	return;
		//if (set_of_edge.size() == 0)
		//	type = 0;
		//if (set_of_edge.size() == 1)
		//	type = 1;
		//else if (set_of_edge.size() == 2 && type > 2)
		//	type = 2;
		ctp2 = ctp1 = (p1 + p2)*0.5f;
	//	return;
		if (type < 2)
			return;
		//fit_quadratic_bezier(t);
		//return;
		if (type == 2)
			fit_quadratic_bezier(t);
		else
			fit_cubic_bezier(t);
	}
	//from : void fit_bezier_lst(const std::vector <T, std::allocator<T>> & samples, std::vector<double>& tSamples, glm::dvec2* bezier_ctrl_pts)
	template<typename Triangulation>
	void fit_quadratic_bezier(Triangulation& t)
	{
		glm::mat3 AA(0.0f);
		glm::vec3 bbx(0.0f, 0.0f, 0.0f), bby(0.0f, 0.0f, 0.0f), xx, b;
		for (std::pair<glm::vec2, double>& p : parametrization)
		{
			bernstein_polynome<2>(p.second, b);
			AA += glm::outerProduct(b, b);
			bbx += p.first.x * b;
			bby += p.first.y * b;
		}
		//auto inv = AA.jacobiSvd(Eigen::ComputeFullU | Eigen::ComputeFullV);
		//xx = AA.jacobiSvd(Eigen::ComputeFullU | Eigen::ComputeFullV).solve(bb);
		//xx = inv.solve(bbx et bby);
		ctp1 = (glm::vec2(bbx[1], bby[1]) - p1 * AA[1][0] - p2 * AA[1][2])* 1.0f / AA[1][1];
		ctp2 = ctp1;
	}
	template<typename Triangulation>
	void fit_cubic_bezier(Triangulation& t)
	{
		glm::mat4 AA(0.0f);
		glm::vec4 bbx(0.0f, 0.0f, 0.0f, 0.0f), bby(0.0f, 0.0f, 0.0f, 0.0f), xx, b;
		for (std::pair<glm::vec2, double>& p : parametrization)
		{
			bernstein_polynome<3>(p.second, b);
			AA += glm::outerProduct(b, b);
			bbx += p.first.x * b;
			bby += p.first.y * b;
		}
		bbx[1] -= (p1.x * AA[1][0] + p2.x * AA[1][3]);
		bby[1] -= (p1.y * AA[1][0] + p2.y * AA[1][3]);
		bbx[2] -= (p1.x * AA[2][0] + p2.x * AA[2][3]);
		bby[2] -= (p1.y * AA[2][0] + p2.y * AA[2][3]);
		glm::mat2 inv = glm::inverse(glm::mat2(AA[1][1], AA[1][2], AA[2][1], AA[2][2]));
		glm::vec2 px = inv * glm::vec2(bbx[1], bbx[2]);
		glm::vec2 py = inv * glm::vec2(bby[1], bby[2]);
		ctp1.x = px.x;
		ctp2.x = px.y;
		ctp1.y = py.x;
		ctp2.y = py.y;
	}

	glm::vec2 grad_(double t)
	{
		switch (type)
		{
		case 0:
			return glm::vec2(0.0, 0.0);
		case 1:
			return grad_1(t);
		case 2:
			return grad_2(t);
		default:
			return grad_3(t);
		}
	}
	glm::vec2 grad_1(float t)
	{
		std::vector<float> d(2);
		bernstein_grad(t, d, 1);
		return p1 * d[0] + p2 * d[1];
	}
	glm::vec2 grad_2(float t)
	{
		std::vector<float> d(3);
		bernstein_grad(t, d, 2);
		return p1 * d[0] + ctp1 * d[1] +  p2 * d[2];
	}
	glm::vec2 grad_3(float t)
	{
		std::vector<float> d(4);
		bernstein_grad(t, d, 3);
		return p1 * d[0] + ctp1 * d[1] + ctp2 * d[2] + p2 * d[3];
	}
	glm::vec2 val(double t)
	{
		switch (type)
		{
		case 0:
			return glm::vec2(0.0, 0.0);
		case 1:
			return val_1(t);
		case 2:
			return val_2(t);
		default:
			return val_3(t);
		}
	}

	glm::vec2 val_1(float t)
	{
		return (1.0f - t)*p1 + t*p2;
	}
	glm::vec2 val_2(float t)
	{
		const float t2 = t*t;
		const float t12 = 2 * t;
		return (t2 - t12 + 1)*p1 + (t12 - 2 * t2)*ctp1 + t2*p2;
	}
	glm::vec2 val_3(float t)
	{
		const float t2 = t*t;
		const float t3 = t2*t;
		const float _3t = t * 3;
		const float _3t2 = t2 * 3;
		const float _3t3 = t3 * 3;
		return (-t3 + _3t2 - _3t + 1)*p1 + (_3t3 - 2 * _3t2 + _3t)*ctp1 + (-_3t3 + _3t2) * ctp2 + t3*p2;
	}
	template<typename Triangulation>
	double energy(Triangulation& t)
	{
		double energy_tmp = 0.0, energy_2=0.0;
		double proba_label_compl = 0.0;
		int nb_pt = 0;
		for (double tt = 0.00; tt < 1.00; tt += 0.001)
		{
			glm::vec2 pt = val(tt);
			const int x = (int)pt.x;
			const int y = (int)pt.y;
			glm::vec2 g = grad_(tt);
			if (ini_data_cost_img::is_in_img(x, y))
			{
				cv::Vec2f grad_I = ini_data_cost_img::img_grad_xy[y][x];
				const float norm = ini_data_cost_img::img_grad[y][x];
				const float color = ini_data_cost_img::img[y][x];
				const float inner_prod_un_is_good = glm::dot(-g, glm::vec2(grad_I[0], grad_I[1]));
				proba_label_compl += std::exp(-norm * inner_prod_un_is_good * inner_prod_un_is_good * 8);
				proba_label_compl += color;//black is better
				++nb_pt;
			}
		}
		energy_tmp = (proba_label_compl *  1.0/ nb_pt);
		double energy_2_max = 0.0;
		std::map<double, glm::vec2> time;
		for (std::pair<glm::vec2, double>& p : parametrization)
		{
			double ttmp = glm::distance(p.first, val(p.second));
			energy_2 +=ttmp;
			if (ttmp > energy_2_max)
				energy_2_max = ttmp;
			time.emplace(p.second,p.first);
			//std::cout << glm::distance(p.first, val(p.second)) << std::endl;
			//std::getc(stdin);
		}
		double max_dt = 0.0;
		double max_dst = 0;
		if (parametrization.size() != 0)
		{
			energy_2 /= parametrization.size();
			double tmp = time.begin()->first;
			glm::vec2 p = time.begin()->second;
			for (const std::pair<double, glm::vec2>& t : time)
			{
				if (t.first - tmp > max_dt)
				{
					max_dt = t.first - tmp;
					max_dst = glm::distance(p, t.second);
				}

				tmp = t.first;
				p = t.second;
			}
		//	std::cout << max_dt << std::endl;
		}
		//(fidelity + simplicity)*ordre de grandeur energy courbe negligeable devant energie edge ...
		return ((energy_2_max + max_dst)*set_of_edge.size() / 40*(1- ini_data_cost_img::cost_different_label) + ini_data_cost_img::cost_different_label*0.45)*ini_data_cost_img::cost_vertex;
		//if (parametrization.size())
		//	energy_tmp += energy_2 / ini_data_cost_img::img.rows / ini_data_cost_img::img.cols;// (energy_2 / parametrization.size());// / ini_data_cost_img::img.rows / ini_data_cost_img::img.cols;
	//	return (ini_data_cost_img::threshold_pb_border - energy_tmp);
//		std::cout <<"e: "<< (1.0 - energy_tmp) * 10 << std::endl;
		//return ((energy_tmp)+energy_2 / ini_data_cost_img::img.rows / ini_data_cost_img::img.cols) *set_of_edge.size();
		//return (energy_tmp)*set_of_edge.size();
//		return (energy_tmp) + max_dt*2 + energy_2;
	}
};
template<template< class, class> typename Triangulation_base_ini, class Triangulation_data_structure_base, class Kernel, typename Label, template< class> typename Cost_vertices_, template< class> typename Cost_edges_, template< class> typename Cost_faces_, typename Ini_data_cost_,  typename Gui_optional_rendering_ = void >
struct Ma_Triangulation_2 : public Triangulation_base_ini<Kernel, Triangulation_data_structure_base>
{
	typedef Triangulation_base_ini<Kernel, Triangulation_data_structure_base> Triangulation_base;
	std::mt19937 gen;
	std::random_device rd;
	std::map<Mon_edge, data<Label>> edge_data;
	std::map<int, data<Label>> vertex_data;
	std::map<int, data<Label>> face_data;
	int curve_next_id;
	std::map<int,curve<Triangulation_base>> list_of_curve;
	typedef Ini_data_cost_ Ini_data_cost;
	typedef Cost_vertices_<Ini_data_cost> Cost_vertices;
	typedef Cost_edges_<Ini_data_cost> Cost_edges;
	typedef Cost_faces_<Ini_data_cost> Cost_faces;
	typedef Gui_optional_rendering_ Gui;
	Ma_Triangulation_2(): rd(), gen(rd())
	{
		curve_next_id = 0;
	}
	Ma_Triangulation_2(int cols, int rows) : rd(), gen(rd())
	{
		ini(cols, rows);
	}
	void ini(int cols, int rows)
	{
		curve_next_id = 0;
		edge_data.clear();
		vertex_data.clear();
		face_data.clear();
		list_of_curve.clear();
		Triangulation_base::insert(typename Triangulation_base::Point(-5, -5))->info() = next_info.vertex();
		Triangulation_base::insert(typename Triangulation_base::Point(cols + 5, -5))->info() = next_info.vertex();
		Triangulation_base::insert(typename Triangulation_base::Point(-5, rows + 5))->info() = next_info.vertex();
		Triangulation_base::insert(typename Triangulation_base::Point(cols + 5, rows + 5))->info() = next_info.vertex();

		ini_data_cost();
	}
	void ini_data_cost()
	{
		face_data.clear();
		vertex_data.clear();
		edge_data.clear();
		list_of_curve.clear();

		for (auto f(Triangulation_base::faces_begin()), it_end(Triangulation_base::faces_end()); f != it_end; ++f)
		{
			data<Label> df;
			int id = f->info();
			if (id == -1)
				id = f->info() = next_info.face();
			auto it = face_data.find(id);
			if (it == face_data.end())
			{
				df.label = Cost_faces::recompute_label<Label>(*this, *f);
				Cost_faces::p_label(*this, *f, df);
				face_data.emplace(id, df);
			}
		}
		for (auto v(Triangulation_base::finite_vertices_begin()), it_end(Triangulation_base::finite_vertices_end()); v != it_end; ++v)
		{
			data<Label> dv;
			int id = v->info();
			if (id == -1)
				std::cout << "   error on line " << __LINE__ << " on file " << __FILE__ << std::endl;
			auto it = vertex_data.find(id);
			if (it == vertex_data.end())
			{
				vertex_data.emplace(id, dv);
			}
		}
		for (int i = 0; i < 3; ++i)
		{
			for (auto v(Triangulation_base::finite_vertices_begin()), it_end(Triangulation_base::finite_vertices_end()); v != it_end; ++v)
			{
				int id = v->info();
				data<Label>& dvref = vertex_data[id];
				dvref.label = Cost_vertices::recompute_label<Label>(*this, *v);
				Cost_vertices::p_label(*this, *v, dvref);
			}
		}
		for (auto e(Triangulation_base::edges_begin()), it_end(Triangulation_base::edges_end()); e != it_end; ++e)
		{
			data<Label> de;
			Mon_edge id(get_vertex(*e, 1)->info(), get_vertex(*e, 2)->info());
			auto it = edge_data.find(id);
			if (it == edge_data.end())
			{
				de.label = Cost_edges::recompute_label<Label>(*this, *e);
			//	de.p_label = Cost_edges::proba_border(*e);
				Cost_edges::p_label(*this, *e, de);
#ifdef USE_LABEL_SKETCH_BE
				if (de.label != 0)
				{
					de.set_of_curve.emplace(curve_next_id);
					list_of_curve.emplace(curve_next_id, curve<Triangulation_base>());
					list_of_curve[curve_next_id].set_of_edge.emplace(id,std::make_pair(get_vertex(*e, 1)->point(), get_vertex(*e, 2)->point()));
					list_of_curve[curve_next_id].fit_curve(*this);
					++curve_next_id;
				}
#endif
				edge_data.emplace(id, de);
			}
		}


		for (auto f(Triangulation_base::faces_begin()), it_end(Triangulation_base::faces_end()); f != it_end; ++f)
			face_data[f->info()].energy = Cost_faces::cost(*this, *f);
		for (auto v(Triangulation_base::finite_vertices_begin()), it_end(Triangulation_base::finite_vertices_end()); v != it_end; ++v)
			vertex_data[v->info()].energy = Cost_vertices::cost(*this, *v);
		for (auto it(Triangulation_base::edges_begin()), it_end(Triangulation_base::edges_end()); it != it_end; ++it)
			edge_data[Mon_edge(get_vertex(*it, 1)->info(), get_vertex(*it, 2)->info())].energy = Cost_edges::cost(*this, *it);
		std::cout << "data cost ini" << std::endl;
	}
	float get_energy_facet()
	{
		float energy = 0;
		for (auto it(Triangulation_base::faces_begin()), it_end(Triangulation_base::faces_end()); it != it_end; ++it)
			energy += Cost_faces::cost(*this, *it);
		return energy;
	}
	float get_energy_edge()
	{
		float energy = 0;
		for (auto it(Triangulation_base::edges_begin()), it_end(Triangulation_base::edges_end()); it != it_end; ++it)
			energy += Cost_edges::cost(*this, *it);
		return energy;
	}
	float get_energy_vertices()
	{
		float energy = 0;
		for (auto it(Triangulation_base::finite_vertices_begin()), it_end(Triangulation_base::finite_vertices_end()); it != it_end; ++it)
			energy += Cost_vertices::cost(*this, *it);
		return energy;
	}
	float get_energy()
	{
		float energy = 0;
		energy += get_energy_facet();
		energy += get_energy_edge();
		energy += get_energy_vertices();
		return energy;
	}//void fill_edge_in_faces(Collection_Faces& lst, std::map<std::pair<const typename Triangulation_base::Vertex*, const typename Triangulation_base::Vertex*>, std::pair<typename Triangulation_base::Face_handle, int>>& set_edge)
	
	template<typename Collection_Faces>
		void fill_edge_in_faces(Collection_Faces& lst, std::map<Mon_edge, std::pair<typename Triangulation_base::Face_handle, int>>& set_edge)
	{
		set_edge.clear();
		auto add_edge_if_good = [&set_edge](typename Triangulation_base::Face_handle& face, const typename Triangulation_base::Vertex* ptr_e1, const typename Triangulation_base::Vertex* ptr_e2, int idx)
		{
		//	const std::pair<const typename Triangulation_base::Vertex*, const typename Triangulation_base::Vertex*> pair_1(ptr_e1, ptr_e2);
		//	const std::pair<const typename Triangulation_base::Vertex*, const typename Triangulation_base::Vertex*> pair_2(ptr_e2, ptr_e1);
		//	if (set_edge.find(pair_1) == set_edge.end() && set_edge.find(pair_2) == set_edge.end())
		//	{
			//if (edge_data.find(Mon_edge(ptr_e1->info(), ptr_e2->info())) == edge_data.end())
			//	std::cout << "unknown edge in add_edge_if_good" << std::endl;
				set_edge.emplace(Mon_edge(ptr_e1->info(), ptr_e2->info()), std::make_pair(face, idx));
		//	}
		};
		for (typename Triangulation_base::Face_handle f : lst)
		{
			const typename Triangulation_base::Vertex_handle vh0 = f->vertex(0);
			const typename Triangulation_base::Vertex_handle vh1 = f->vertex(1);
			const typename Triangulation_base::Vertex_handle vh2 = f->vertex(2);
			const typename Triangulation_base::Vertex* v0 = &*vh0;
			const typename Triangulation_base::Vertex* v1 = &*vh1;
			const typename Triangulation_base::Vertex* v2 = &*vh2;
			if (vh0 != nullptr && !Triangulation_base::is_infinite(vh0))
			{
				if (vh1 != nullptr && !Triangulation_base::is_infinite(vh1))
				{
					add_edge_if_good(f, v0, v1, 2);
					if (vh2 != nullptr && !Triangulation_base::is_infinite(vh2))
					{
						add_edge_if_good(f, v0, v2, 1);
						add_edge_if_good(f, v1, v2, 0);
					}
				}
				else if (vh2 != nullptr && !Triangulation_base::is_infinite(vh2))
				{
					add_edge_if_good(f, v0, v2, 1);
				}
		}
			else if (vh1 != nullptr && !Triangulation_base::is_infinite(vh1) && vh2 != nullptr && !Triangulation_base::is_infinite(vh2))
			{
				add_edge_if_good(f, v1, v2, 0);
			}
		}
	}
	template<typename Generator>
	float move_if_energy_good(typename Triangulation_base::Vertex_handle vertex_to_move, const double& threshold_delta_energy, Generator& gen, const int& img_cols, const int& img_rows)
	{
		//return 0.0f;
		//return 0.0f;
		std::set<int> active_curve;
		std::set<Mon_edge> active_edge;
		const typename Triangulation_base::Point point = vertex_to_move->point();
		const int x = (int)point.x();
		const int y = (int)point.y();
		float energy = 0.0f, energy_v2 = 0.0f;
		if (x > 0 && y > 0 && x < img_cols - 1 && y < img_rows - 1)
		{
			int a = std::uniform_int_distribution<int>(0, 7)(gen);
			if (a > 3)
				++a;
			int b = std::uniform_int_distribution<int>(1, 3)(gen);
			const typename Triangulation_base::Point new_point = typename Triangulation_base::Point(x + (a / 3 - 1)*b, y + (a % 3 - 1)*b);

			if (new_point.x() < 0 || new_point.y() < 0 || new_point.x() >= img_cols || new_point.y() >= img_rows)
				return 0.0f;
		//	std::cout << point.x() << " " << point.y() << " " << new_point.x() << " " << new_point.y() << " " << Triangulation_base::is_delaunay_after_displacement(vertex_to_move, new_point) << std::endl;
			if (Triangulation_base::is_delaunay_after_displacement(vertex_to_move, new_point))
			{
				typename Triangulation_base::Edge_circulator ec = Triangulation_base::incident_edges(vertex_to_move);
				typename Triangulation_base::Edge_circulator ec_end = ec;
				do
				{
					Mon_edge me(get_vertex(*ec, 1)->info(), get_vertex(*ec, 2)->info());
					data<Label>& de = edge_data[me];
					Cost_edges::p_label(*this, *ec, de);

					energy += Cost_edges::cost(*this, *ec);

#ifdef USE_LABEL_SKETCH_BE
					for (const int& id_curve : de.set_of_curve)
						active_curve.emplace(id_curve);
					active_edge.emplace(me);
#endif
				} while (ec_end != ++ec);
#ifdef USE_LABEL_SKETCH_BE
				for(const int& id_c : active_curve)
					energy += list_of_curve[id_c].energy(*this);
#endif
				typename Triangulation_base::Vertex_circulator vc = Triangulation_base::incident_vertices(vertex_to_move);
				typename Triangulation_base::Vertex_circulator vc_end = vc;
				do
				{
					Cost_vertices::p_label(*this, *vc, vertex_data[vc->info()]);
					energy += Cost_vertices::cost(*this, *vc);
				} while (vc_end != ++vc);
				Cost_vertices::p_label(*this, *vertex_to_move, vertex_data[vertex_to_move->info()]);
				energy += Cost_vertices::cost(*this, *vertex_to_move);

				typename Triangulation_base::Face_circulator fc = Triangulation_base::incident_faces(vertex_to_move);
				typename Triangulation_base::Face_circulator fc_end = fc;
				do
				{
					//update color
				//	face_data[fc->info()].color = Cost_faces::recompute_new_color_on_face_cst(*this, *fc, face_data[fc->info()].label);// vertex_data[id].color;
					Cost_faces::p_label(*this, *fc, face_data[fc->info()]);


					energy += Cost_faces::cost(*this, *fc);
				} while (fc_end != ++fc);
			//	remove_edge_cost(vertex_to_move);
				//Triangulation_base::move_if_no_collision(vertex_to_move, new_point);
				vertex_to_move = Triangulation_base::move(vertex_to_move, new_point);
				bool is_good_triangulation__ie_unique = true;
				typename Triangulation::Face_circulator c = vertex_to_move->incident_faces();
				typename Triangulation::Face_circulator c_end = c;
				do
				{
					const typename Triangulation::Point pt1 = this->dual(c);
					for (int kkk = 0; kkk < 3; ++kkk)
					{
						const typename Triangulation::Point pt2 = this->dual(c->neighbor(kkk));
						if (pt2 == pt1)
						{
							std::cout << "bad triangulation: move rejected" << std::endl;
							is_good_triangulation__ie_unique = false;
						}
					}
				} while (++c != c_end);
#ifdef USE_LABEL_SKETCH_BE
				for (const Mon_edge& id_edge : active_edge)
				{
					for (const int& id_curve : edge_data[id_edge].set_of_curve)
					{
						std::pair<typename Triangulation_base::Point, typename Triangulation_base::Point>& p = list_of_curve[id_curve].set_of_edge[id_edge];
						if (p.first == point)
							p.first = new_point;
						if (p.second == point)
							p.second = new_point;
					}
				}
				for (const int& id_curve : active_curve)
				{
					//for (std::pair<const int, std::pair<typename Triangulation_base::Point, typename Triangulation_base::Point>>& pair : list_of_curve[id_curve].set_of_edge)
					//{
					//	std::pair<typename Triangulation_base::Point, typename Triangulation_base::Point>& p = pair.second;
					//	if (p.first == point)
					//		p.first = new_point;
					//	if (p.second == point)
					//		p.second = new_point;
					//}
					list_of_curve[id_curve].fit_curve(*this);
					energy_v2 += list_of_curve[id_curve].energy(*this);
				}
#endif
				vc = Triangulation_base::incident_vertices(vertex_to_move);
				vc_end = vc;
				do
				{
					Cost_vertices::p_label(*this, *vc, vertex_data[vc->info()]);
					energy_v2 += Cost_vertices::cost(*this, *vc);
				} while (vc_end != ++vc);
				Cost_vertices::p_label(*this, *vertex_to_move, vertex_data[vertex_to_move->info()]);
				energy_v2 += Cost_vertices::cost(*this, *vertex_to_move);
				fc = Triangulation_base::incident_faces(vertex_to_move);
				fc_end = fc;
				do
				{
					//face_data[fc->info()].color = Cost_faces::recompute_new_color_on_face_cst(*this, *fc, face_data[fc->info()].label);// vertex_data[id].color;
					Cost_faces::p_label(*this, *fc, face_data[fc->info()]);
					energy_v2 += Cost_faces::cost(*this, *fc);
				} while (fc_end != ++fc);
				ec = Triangulation_base::incident_edges(vertex_to_move);
				ec_end = ec;
				do
				{
					Mon_edge me(get_vertex(*ec, 1)->info(), get_vertex(*ec, 2)->info());
					data<Label>& de = edge_data[me];
					Cost_edges::p_label(*this, *ec, de);

					energy_v2 += Cost_edges::cost(*this, *ec);

				} while (ec_end != ++ec);


				if (energy_v2 - energy > threshold_delta_energy || !is_good_triangulation__ie_unique)
				{
					//Triangulation_base::move_if_no_collision(vertex_to_move, point);
					vertex_to_move = Triangulation_base::move(vertex_to_move, point);
		//			remove_edge_cost(vertex_to_move);

#ifdef USE_LABEL_SKETCH_BE
					for (const Mon_edge& id_edge : active_edge)
					{
						for (const int& id_curve : edge_data[id_edge].set_of_curve)
						{
							std::pair<typename Triangulation_base::Point, typename Triangulation_base::Point>& p = list_of_curve[id_curve].set_of_edge[id_edge];
							if (p.first == new_point)
								p.first = point;
							if (p.second == new_point)
								p.second = point;
						}
					}
					for (const int& id_curve : active_curve)
					{
						list_of_curve[id_curve].fit_curve(*this);
					}
					//for (const int& id_curve : active_curve)
					//{
					//	for (std::pair<typename Triangulation_base::Point, typename Triangulation_base::Point>& p : list_of_curve[id_curve].set_of_edge)
					//	{
					//		if (p.first == new_point)
					//			p.first = point;
					//		if (p.second == new_point)
					//			p.second = point;
					//	}
					//	list_of_curve[id_curve].fit_curve(*this);
					//}
#endif
					vc = Triangulation_base::incident_vertices(vertex_to_move);
					vc_end = vc;
					do
					{
						Cost_vertices::p_label(*this, *vc, vertex_data[vc->info()]);
					} while (vc_end != ++vc);
					Cost_vertices::p_label(*this, *vertex_to_move, vertex_data[vertex_to_move->info()]); 
					fc = Triangulation_base::incident_faces(vertex_to_move);
					fc_end = fc;
					do
					{
						//face_data[fc->info()].color = Cost_faces::recompute_new_color_on_face_cst(*this, *fc, face_data[fc->info()].label);// vertex_data[id].color;
						Cost_faces::p_label(*this, *fc, face_data[fc->info()]);
						//energy_v2 += Cost_faces::cost(*this, *fc);
					} while (fc_end != ++fc);
					ec = Triangulation_base::incident_edges(vertex_to_move);
					ec_end = ec;
					do
					{
						Mon_edge me(get_vertex(*ec, 1)->info(), get_vertex(*ec, 2)->info());
						data<Label>& de = edge_data[me];
						Cost_edges::p_label(*this, *ec, de);

					} while (ec_end != ++ec);
					return 0.0f;
				}
		//		std::cout << "move" << std::endl;
				return energy_v2 - energy;
			}
			else
			{
				return 0.0f;
			//	remove_edge_cost(vertex_to_move);
			//	Triangulation_base::remove(vertex_to_move);
			//	return insertion_from_move(point, new_point, threshold_delta_energy);
			}
		}
		return 0.0f;
	}
	float split_curve_if_energy_good(const double& threshold_delta_energy)
	{
		//	return 0.0f;
#ifndef USE_LABEL_SKETCH_BE
		return 0.0f;
#endif
		if (list_of_curve.size() == 0)
			return 0.0f;
		std::set<int> id_splitable_curve;
		for (const auto& a : list_of_curve)
			if (a.second.set_of_edge.size() > 1)
				id_splitable_curve.emplace(a.first);
		if (id_splitable_curve.size() == 0)
			return 0.0f;
		int id_source_curve = *std::next(std::begin(id_splitable_curve), std::uniform_int_distribution<int>(0, (int)(id_splitable_curve.size() - 1))(gen));
		auto& source_curve = list_of_curve[id_source_curve];
		auto& source_set_edge = source_curve.set_of_edge;
		const int nb_edge_source = (int)source_set_edge.size();
		float energy_1 = source_curve.energy(*this);

		std::map<double, Mon_edge> ordered_edge_set;
		float inv_len = 1.0 / glm::length(source_curve.p2 - source_curve.p1);
		glm::vec2 dir = (source_curve.p2 - source_curve.p1)*inv_len;
		for (const auto& point : source_set_edge)
		{
			glm::vec2 tmp = (glm::vec2(point.second.first.x(), point.second.first.y()) +
				glm::vec2(point.second.second.x(), point.second.second.y()))*0.5f;
			ordered_edge_set.emplace(glm::dot(dir, tmp - source_curve.p1)*inv_len, point.first);
		}
		int id_split = std::uniform_int_distribution<int>(1, (int)(ordered_edge_set.size() - 1))(gen);//when split keep at least one curve in source curve

		int id_target_curve = curve_next_id;
		++curve_next_id;
		list_of_curve.emplace(id_target_curve, curve<Triangulation_base>());
		auto& target_curve = list_of_curve[id_target_curve];
		auto& target_set_edge = target_curve.set_of_edge;
		for (auto it = std::next(ordered_edge_set.begin(), id_split), it_end = ordered_edge_set.end(); it != it_end; ++it)
		{
			auto it_2 = source_set_edge.find(it->second);
			target_set_edge.emplace(it_2->first, it_2->second);
			source_set_edge.erase(it_2);
		}
		source_curve.fit_curve(*this);
		target_curve.fit_curve(*this);
		float energy_2 = source_curve.energy(*this) + target_curve.energy(*this);


		if (energy_2 - energy_1 > threshold_delta_energy)
		{
			for (const auto& a : target_set_edge)
				source_set_edge.emplace(a.first, a.second);
			source_curve.fit_curve(*this);
			list_of_curve.erase(list_of_curve.find(id_target_curve));
			--curve_next_id;
			return 0.0f;
		}
		//	std::getc(stdin);
		for (const auto& a : target_set_edge)
		{
			auto& edge_data_set_of_curve = edge_data[a.first].set_of_curve;
			edge_data_set_of_curve.erase(edge_data_set_of_curve.find(id_source_curve));
			edge_data_set_of_curve.emplace(id_target_curve);
		}
		return energy_2 - energy_1;
	}
	
	float merge_curve_if_energy_good(const double& threshold_delta_energy)
	{
	//	return 0.0f;
#ifndef USE_LABEL_SKETCH_BE
		return 0.0f;
#endif
		if (list_of_curve.size() < 2)
			return 0.0f;
		int source_curve = std::uniform_int_distribution<int>(0, (int)(list_of_curve.size() - 1))(gen);
		int target_curve;
		int tmp_aa = std::next(std::begin(list_of_curve), source_curve)->first;

		std::set<int> adj_curve;
		for (auto itbase(this->finite_edges_begin()), it_end(this->finite_edges_end()); itbase != it_end; ++itbase)
		{
			const auto& face = *itbase->first;
			const int& idx = itbase->second;
			const auto& v1 = face.vertex((idx + 1) % 3);
			const auto& v2 = face.vertex((idx + 2) % 3);
			const auto& p1 = v1->point();
			const auto& p2 = v2->point();
			const data& de = edge_data[Mon_edge(v1->info(), v2->info())];
			auto it = de.set_of_curve.find(tmp_aa);
			if (it != de.set_of_curve.end())
			{
				for (const int& i : de.set_of_curve)
					if (i != tmp_aa)
						adj_curve.emplace(i);
				typename Triangulation_base::Vertex_circulator vc, vc_end;
				vc = vc_end = v1->incident_vertices();
				do
				{
					if (vc != v2)
					{
						for (const int& i : edge_data[Mon_edge(v1->info(), vc->info())].set_of_curve)
							if (i != tmp_aa)
								adj_curve.emplace(i);
					}
				} while (++vc != vc_end);
				vc = vc_end = v2->incident_vertices();
				do
				{
					if (vc != v1)
					{
						for (const int& i : edge_data[Mon_edge(v2->info(), vc->info())].set_of_curve)
							if (i != tmp_aa)
								adj_curve.emplace(i);
					}
				} while (++vc != vc_end);
			}
		}
		if (adj_curve.size() == 0)
			return 0.0f;
		target_curve = std::uniform_int_distribution<int>(0, (int)(adj_curve.size() - 1))(gen);
		target_curve = *std::next(std::begin(adj_curve), target_curve);
		//do
		//{
		//	target_curve = std::uniform_int_distribution<int>(0, list_of_curve.size() - 1)(gen);
		//} while (source_curve == target_curve);
		//target_curve = std::next(std::begin(list_of_curve), target_curve)->first;
		source_curve = std::next(std::begin(list_of_curve), source_curve)->first;
		float energy_1 = list_of_curve[source_curve].energy(*this) + list_of_curve[target_curve].energy(*this);
		const int nb_edge_source = (int)list_of_curve[source_curve].set_of_edge.size();
		const int nb_edge_target = (int)list_of_curve[target_curve].set_of_edge.size();
		std::set<Mon_edge> unique_edge;
		auto& target_set_edge = list_of_curve[target_curve].set_of_edge;
		auto& source_set_edge = list_of_curve[source_curve].set_of_edge;
		for (const auto& a : source_set_edge)
		{
			if(target_set_edge.find(a.first)==target_set_edge.end())
			{
				unique_edge.emplace(a.first);
				target_set_edge.emplace(a);
			}
		}
		//list_of_curve[target_curve].set_of_edge.splice(list_of_curve[target_curve].set_of_edge.end(), list_of_curve[source_curve].set_of_edge);
		list_of_curve[target_curve].fit_curve(*this);
		float energy_2 = list_of_curve[target_curve].energy(*this);
		if (energy_2 - energy_1 > threshold_delta_energy)
		{
			for (const Mon_edge& a : unique_edge)
				target_set_edge.erase(target_set_edge.find(a));
			//list_of_curve[source_curve].set_of_edge.splice(
			//	list_of_curve[source_curve].set_of_edge.end(),
			//	list_of_curve[target_curve].set_of_edge,
			//	std::next(list_of_curve[target_curve].set_of_edge.begin(), nb_edge_target),
			//	list_of_curve[target_curve].set_of_edge.end());
			list_of_curve[target_curve].fit_curve(*this);
			return 0.0f;
		}
	//	std::getc(stdin);
		for (const auto& a : source_set_edge)
		{
			auto& edge_data_set_of_curve = edge_data[a.first].set_of_curve;
			edge_data_set_of_curve.erase(edge_data_set_of_curve.find(source_curve));
			edge_data_set_of_curve.emplace(target_curve);
		}
		//for (std::pair<const Mon_edge, data>& d : edge_data)
		//{
		//	auto it = d.second.set_of_curve.find(source_curve);
		//	if (it != d.second.set_of_curve.end())
		//	{
		//		d.second.set_of_curve.erase(it);
		//		d.second.set_of_curve.emplace(target_curve);
		//	}
		//}
		list_of_curve.erase(list_of_curve.find(source_curve));
		return energy_2 - energy_1;
	}
	
	float change_label_edge_if_energy_good(const typename Triangulation_base::Edge& edge, const double& threshold_delta_energy, int new_label)
	{
		//return 0.0f;
		//std::getc(stdin);
	//	std::cout << "nb curve ini: " << list_of_curve.size() << std::endl;
		const typename Triangulation_base::Vertex_handle v1 = get_vertex(edge, 1);
		const typename Triangulation_base::Vertex_handle v2 = get_vertex(edge, 2);
		const typename Triangulation_base::Face_handle f1 = edge.first;
		const typename Triangulation_base::Face_handle f2 = edge.first->neighbor(edge.second);
		const int i1 = v1->info();
		const int i2 = v2->info();


		if (i1 < 4 || i2 < 4)
			return 0.0f;


		Mon_edge ed(i1, i2);
		auto it = edge_data.find(ed);
		if (it == edge_data.end())
			std::cout << "*@!" << std::endl;

		data<Label>& df1 = face_data[f1->info()];
		data<Label>& df2 = face_data[f2->info()];
		data<Label>& dv1 = vertex_data[i1];
		data<Label>& dv2 = vertex_data[i2];
		data<Label>& de = edge_data[ed];
		const Label l = de.label;


#ifdef USE_LABEL_SKETCH_BE
		std::set<int>& curve_current = de.set_of_curve;
		std::set<int> curve_edge_around;
		typename Triangulation_base::Vertex_circulator c = v1->incident_vertices();
		typename Triangulation_base::Vertex_circulator c_end = c;
		do
		{
			Mon_edge tmp(i1, c->info());
			for(const int& i : edge_data[tmp].set_of_curve)
				if (curve_current.find(i) == curve_current.end())
					curve_edge_around.emplace(i);
		} while (++c != c_end);
		c = v2->incident_vertices();
		c_end = c;
		do
		{
			Mon_edge tmp(i2, c->info());
			for (const int& i : edge_data[tmp].set_of_curve)
				if (curve_current.find(i) == curve_current.end())
					curve_edge_around.emplace(i);
		} while (++c != c_end);
		int nb_current_curve = (int)curve_current.size();
		int nb_curve_around = (int)curve_edge_around.size();
		int mode = std::uniform_int_distribution<int>(0, 2)(gen);
	//	if(mode==2)
	//	int add_curve = std::uniform_int_distribution<int>(0, nb_current_curve + nb_curve_around + 1 - 1)(gen);
		if (nb_current_curve == 0 && nb_curve_around == 0)
			mode = 2;
		if (nb_curve_around== 0 && mode == 1)
			mode = 2 * std::uniform_int_distribution<int>(0, 1)(gen);
		if (nb_current_curve == 0 && mode == 0)
			mode = 1 + std::uniform_int_distribution<int>(0, 1)(gen);
		bool is_new_curve = (mode != 0);
		bool is_totally_new_curve = (mode == 2);
		int index_curve_change;
		if (is_new_curve)
		{
			if (is_totally_new_curve)
			{
				de.set_of_curve.emplace(curve_next_id);
				list_of_curve.emplace(curve_next_id, curve<Triangulation_base>());
				list_of_curve[curve_next_id].set_of_edge.emplace(ed, std::make_pair(v1->point(), v2->point()));
				list_of_curve[curve_next_id].fit_curve(*this);
				index_curve_change = curve_next_id;
				++curve_next_id;
			}
			else
				index_curve_change = *std::next(curve_edge_around.begin(), std::uniform_int_distribution<int>(0, nb_curve_around - 1)(gen));
		}
		else
		{
			index_curve_change = *std::next(curve_current.begin(), std::uniform_int_distribution<int>(0, nb_current_curve - 1)(gen));
			//index_curve_change = *std::next(curve_current.begin(), add_curve);
		}
		auto& lst_curve= list_of_curve[index_curve_change];
		auto& lst_curve_set_edge = lst_curve.set_of_edge;
#endif
		//float energy_1 = df1.energy + df2.energy + dv1.energy + dv2.energy + de.energy;
		float ef1_tmp, ef2_tmp, ev1_tmp, ev2_tmp, ee_tmp;
		float energy_1 = (ef1_tmp = Cost_faces::cost(*this, *f1)) + (ef2_tmp = Cost_faces::cost(*this, *f2))
			+ (ev1_tmp = Cost_vertices::cost(*this, *v1)) + (ev2_tmp = Cost_vertices::cost(*this, *v2))
			+ (ee_tmp = Cost_edges::cost(*this, edge));

#ifdef USE_LABEL_SKETCH_BE
		if(!is_totally_new_curve)
			energy_1 += lst_curve.energy(*this);
#endif

		float pl = de.p_label;
		Cost_edges::p_label(*this, edge, de);
		if (pl != de.p_label)
		{
			std::cout << "p_label " << pl << " " << de.p_label << " " << ed.id_edge << std::endl;
			std::getc(stdin);
		}


		float energy_1__2 = (ef1_tmp = Cost_faces::cost(*this, *f1)) + (ef2_tmp = Cost_faces::cost(*this, *f2))
			+ (ev1_tmp = Cost_vertices::cost(*this, *v1)) + (ev2_tmp = Cost_vertices::cost(*this, *v2))
			+ (ee_tmp = Cost_edges::cost(*this, edge));

#ifdef USE_LABEL_SKETCH_BE
		if(!is_totally_new_curve)
			energy_1__2 += lst_curve.energy(*this);
#endif
		if (energy_1 != energy_1__2)
		{
			std::cout << "e_p_label_change_label " << energy_1 << " " << energy_1__2 << std::endl;
			std::getc(stdin);
		}

#ifdef USE_LABEL_SKETCH_BE
		if (is_totally_new_curve)
		{

		}
		else if (is_new_curve)
		{
			de.set_of_curve.emplace(index_curve_change);
			lst_curve_set_edge.emplace(ed, std::make_pair(v1->point(), v2->point()));
		}
		else
		{
			de.set_of_curve.erase(de.set_of_curve.find(index_curve_change));
			lst_curve_set_edge.erase(lst_curve_set_edge.find(ed));
	//		std::list<std::pair<typename Triangulation::Point, typename Triangulation::Point>>& lc_se = list_of_curve[index_curve_change].set_of_edge;
	//	//	std::cout << lc_se.size() << "   ";
	//		//std::set<std::list<std::pair<typename Triangulation::Vertex*, typename Triangulation::Vertex*>>::iterator> to_rm;
	//		for (std::list<std::pair<typename Triangulation::Point, typename Triangulation::Point>>::iterator
	//			it(lc_se.begin()), it_end(lc_se.end()); it != it_end; ++it)
	//		{
	//			if ((it->first == v1->point() && it->second == v2->point()) || (it->second == v1->point() && it->first == v2->point()))
	//			{
	//				lc_se.erase(it);
	//				break;
	//			}
	//		}
	//		std::cout << lc_se.size() << std::endl;
		}
		lst_curve.fit_curve(*this);
#endif

		de.label = new_label;

#ifdef USE_LABEL_SKETCH_BE
		de.label = (de.set_of_curve.size() != 0);
#endif
		float ef1, ef2, ev1, ev2, ee;
		Cost_edges::p_label(*this, edge, de);
		float energy_2 = (ef1 = Cost_faces::cost(*this, *f1)) + (ef2 = Cost_faces::cost(*this, *f2))
			+ (ev1 = Cost_vertices::cost(*this, *v1)) + (ev2 = Cost_vertices::cost(*this, *v2))
			+ (ee = Cost_edges::cost(*this, edge));
#ifdef USE_LABEL_SKETCH_BE
		energy_2 += lst_curve.energy(*this);
		const int op = (is_totally_new_curve ? 2 : is_new_curve ? 1 : 0);
#endif
		//std::cout << threshold_delta_energy << std::endl;
		if (energy_2 - energy_1 > threshold_delta_energy )
		{
			df1.energy = ef1_tmp;
			df2.energy = ef2_tmp;
			dv1.energy = ev1_tmp;
			dv2.energy = ev2_tmp;
			de.energy = ee_tmp;
			de.label = l;
			Cost_edges::p_label(*this, edge, de);
		//	if (pl != de.p_label)std::getc(stdin);


#ifdef USE_LABEL_SKETCH_BE
			if (is_totally_new_curve)
			{
			//	std::cout << list_of_curve.size() << std::endl;
					list_of_curve.erase(list_of_curve.find(index_curve_change));
			//		std::cout <<  list_of_curve.size() <<std::endl;
					--curve_next_id;
					de.set_of_curve.erase(de.set_of_curve.find(index_curve_change));
			}
			else if (is_new_curve)
			{
				de.set_of_curve.erase(de.set_of_curve.find(index_curve_change));
				lst_curve_set_edge.erase(lst_curve_set_edge.find(ed));
				lst_curve.fit_curve(*this);
			}
			else
			{
				de.set_of_curve.emplace(index_curve_change);
				lst_curve_set_edge.emplace(ed, std::make_pair(v1->point(), v2->point()));
				lst_curve.fit_curve(*this);
			}
#endif



			float energy_1 = (ef1_tmp = Cost_faces::cost(*this, *f1)) + (ef2_tmp = Cost_faces::cost(*this, *f2))
				+ (ev1_tmp = Cost_vertices::cost(*this, *v1)) + (ev2_tmp = Cost_vertices::cost(*this, *v2))
				+ (ee_tmp = Cost_edges::cost(*this, edge));
		//	if (energy_1 != energy_1__2)
		//	{
		//		std::cout << "e_p_label_change_label v2 " << energy_1 << " " << energy_1__2 << std::endl;
		//		std::getc(stdin);
		//	}
		//	std::cout << "nb curve after REVERT: " << list_of_curve.size() << " op: " << op << std::endl;
		//	if (op == 2)
		//		std::getc(stdin);
			return 0.0f;
		}
#ifdef USE_LABEL_SKETCH_BE
		if (lst_curve_set_edge.size() == 0)
			list_of_curve.erase(list_of_curve.find(index_curve_change));
#endif
		df1.energy = ef1;
		df2.energy = ef2;
		dv1.energy = ev1;
		dv2.energy = ev2;
		de.energy = ee;
//		std::cout << "nb curve after end: " << list_of_curve.size() << " op: " << op << std::endl;
//		if (mode == 0)
//			std::getc(stdin);
		return energy_2 - energy_1;
	}
	float change_label_face_if_energy_good(const typename Triangulation_base::Face_handle& face, const double& threshold_delta_energy, int new_label)
	{
		std::array<typename Triangulation_base::Vertex_handle, 3> vertex_around = { face->vertex(0) , face->vertex(1), face->vertex(2) };
		for (typename Triangulation_base::Vertex_handle v : vertex_around)
			if (v->info() < 4)
				return 0.0f;
	//	std::cout << "begin change label" << std::endl;
		std::array<typename Triangulation_base::Face_handle, 4> face_around = { face, face->neighbor(0) , face->neighbor(1), face->neighbor(2) };
		std::array<typename Triangulation_base::Edge, 3> edge_around = { typename Triangulation_base::Edge(face,0),typename Triangulation_base::Edge(face,1),typename Triangulation_base::Edge(face,2) };
		std::array<data*, 4> df = { &face_data[face_around[0]->info()], &face_data[face_around[1]->info()], &face_data[face_around[2]->info()], &face_data[face_around[3]->info()] };
		std::array<data*, 3> de = { &edge_data[get_mon_edge(edge_around[0])], &edge_data[get_mon_edge(edge_around[1])], &edge_data[get_mon_edge(edge_around[2])] };
		std::array<data*, 3> dv = { &vertex_data[vertex_around[0]->info()], &vertex_data[vertex_around[1]->info()], &vertex_data[vertex_around[2]->info()] };
		const int l = df[0]->label;
		
		//const float energy_1 = df[0]->energy + df[1]->energy + df[2]->energy + df[3]->energy
		//	+ de[0]->energy + de[1]->energy + de[2]->energy	+ dv[0]->energy + dv[1]->energy + dv[2]->energy;

		std::array<float, 4> ef1 = { Cost_faces::cost(*this, *face_around[0]), Cost_faces::cost(*this, *face_around[1]), Cost_faces::cost(*this, *face_around[2]), Cost_faces::cost(*this, *face_around[3]) };
		std::array<float, 3> ee1 = { Cost_edges::cost(*this, edge_around[0]), Cost_edges::cost(*this, edge_around[1]), Cost_edges::cost(*this, edge_around[2]) };
		std::array<float, 3> ev1 = { Cost_vertices::cost(*this, *vertex_around[0]), Cost_vertices::cost(*this, *vertex_around[1]), Cost_vertices::cost(*this, *vertex_around[2]) };
		df[0]->label =new_label;
		std::array<float, 4> ef2 = { Cost_faces::cost(*this, *face_around[0]), Cost_faces::cost(*this, *face_around[1]), Cost_faces::cost(*this, *face_around[2]), Cost_faces::cost(*this, *face_around[3]) };
		std::array<float, 3> ee2 = { Cost_edges::cost(*this, edge_around[0]), Cost_edges::cost(*this, edge_around[1]), Cost_edges::cost(*this, edge_around[2]) };
		std::array<float, 3> ev2 = { Cost_vertices::cost(*this, *vertex_around[0]), Cost_vertices::cost(*this, *vertex_around[1]), Cost_vertices::cost(*this, *vertex_around[2]) };

		const float energy_1 = ef1[0] + ef1[1] + ef1[2] + ef1[3] + ee1[0] + ee1[1] + ee1[2] + ev1[0] + ev1[1] + ev1[2];
		const float energy_2 = ef2[0] + ef2[1] + ef2[2] + ef2[3] + ee2[0] + ee2[1] + ee2[2] + ev2[0] + ev2[1] + ev2[2];

		if (energy_2 - energy_1 > threshold_delta_energy)
		{
			df[0]->label = l;
			df[0]->energy = ef1[0]; df[1]->energy = ef1[1]; df[2]->energy = ef1[2]; df[3]->energy = ef1[3];
			de[0]->energy = ee1[0]; de[1]->energy = ee1[1]; de[2]->energy = ee1[2];
			dv[0]->energy = ev1[0]; dv[1]->energy = ev1[1]; dv[2]->energy = ev1[2];
	//		std::cout << "end 0" << std::endl;
			return 0.0f;
		}
		df[0]->energy = ef2[0]; df[1]->energy = ef2[1]; df[2]->energy = ef2[2]; df[3]->energy = ef2[3];
		de[0]->energy = ee2[0]; de[1]->energy = ee2[1]; de[2]->energy = ee2[2];
		dv[0]->energy = ev2[0]; dv[1]->energy = ev2[1]; dv[2]->energy = ev2[2];

	//	std::cout << "end 1" << std::endl;
		return energy_2 - energy_1;
	}
	float change_label_vertex_partition_if_energy_good(const typename Triangulation_base::Vertex_handle& vertex, const double& threshold_delta_energy, int new_label)
	{
		return 0.0f;
	}
	float change_label_face_partition_if_energy_good(const typename Triangulation_base::Face_handle& face, const double& threshold_delta_energy, int new_label)
	{
		std::array<typename Triangulation_base::Vertex_handle, 3> vertex_around = { face->vertex(0) , face->vertex(1), face->vertex(2) };
		std::array<typename Triangulation_base::Face_handle, 4> face_around = { face, face->neighbor(0) , face->neighbor(1), face->neighbor(2) };
		std::array<typename Triangulation_base::Edge, 3> edge_around = { typename Triangulation_base::Edge(face,0),typename Triangulation_base::Edge(face,1),typename Triangulation_base::Edge(face,2) };
		std::array<data<Label>*, 4> df = { &face_data[face_around[0]->info()], &face_data[face_around[1]->info()], &face_data[face_around[2]->info()], &face_data[face_around[3]->info()] };
		std::array<data<Label>*, 3> de = { &edge_data[get_mon_edge(edge_around[0])], &edge_data[get_mon_edge(edge_around[1])], &edge_data[get_mon_edge(edge_around[2])] };
		std::array<data<Label>*, 3> dv = { &vertex_data[vertex_around[0]->info()], &vertex_data[vertex_around[1]->info()], &vertex_data[vertex_around[2]->info()] };
		
		const Label saved_label = df[0]->label;
		Cost_faces::p_label(*this, *face, *df[0]);
	//	df[0]->color = Cost_faces::recompute_new_color_on_face_cst(*this, *face, df[0]->label);// vertex_data[id].color;
		
		std::array<float, 4> ef1 = { Cost_faces::cost(*this, *face_around[0]), Cost_faces::cost(*this, *face_around[1]), Cost_faces::cost(*this, *face_around[2]), Cost_faces::cost(*this, *face_around[3]) };
		std::array<float, 3> ee1 = { Cost_edges::cost(*this, edge_around[0]), Cost_edges::cost(*this, edge_around[1]), Cost_edges::cost(*this, edge_around[2]) };
		std::array<float, 3> ev1 = { Cost_vertices::cost(*this, *vertex_around[0]), Cost_vertices::cost(*this, *vertex_around[1]), Cost_vertices::cost(*this, *vertex_around[2]) };

		df[0]->label.label = new_label;
		const float saved_p_label = df[0]->p_label;
		Cost_faces::p_label(*this, *face, *df[0]);
	//	df[0]->color = Cost_faces::recompute_new_color_on_face_cst(*this, *face, new_label);// vertex_data[id].color;



		std::array<float, 4> ef2 = { Cost_faces::cost(*this, *face_around[0]), Cost_faces::cost(*this, *face_around[1]), Cost_faces::cost(*this, *face_around[2]), Cost_faces::cost(*this, *face_around[3]) };
		std::array<float, 3> ee2 = { Cost_edges::cost(*this, edge_around[0]), Cost_edges::cost(*this, edge_around[1]), Cost_edges::cost(*this, edge_around[2]) };
		std::array<float, 3> ev2 = { Cost_vertices::cost(*this, *vertex_around[0]), Cost_vertices::cost(*this, *vertex_around[1]), Cost_vertices::cost(*this, *vertex_around[2]) };

		const float energy_1 = ef1[0] + ef1[1] + ef1[2] + ef1[3] + ee1[0] + ee1[1] + ee1[2] + ev1[0] + ev1[1] + ev1[2];
		const float energy_2 = ef2[0] + ef2[1] + ef2[2] + ef2[3] + ee2[0] + ee2[1] + ee2[2] + ev2[0] + ev2[1] + ev2[2];

		if (energy_2 - energy_1 > threshold_delta_energy)
		{
			df[0]->label = saved_label;
			df[0]->p_label = saved_p_label;
			df[0]->energy = ef1[0]; df[1]->energy = ef1[1]; df[2]->energy = ef1[2]; df[3]->energy = ef1[3];
			de[0]->energy = ee1[0]; de[1]->energy = ee1[1]; de[2]->energy = ee1[2];
			dv[0]->energy = ev1[0]; dv[1]->energy = ev1[1]; dv[2]->energy = ev1[2];
			//		std::cout << "end 0" << std::endl;
			return 0.0f;
		}
		df[0]->energy = ef2[0]; df[1]->energy = ef2[1]; df[2]->energy = ef2[2]; df[3]->energy = ef2[3];
		de[0]->energy = ee2[0]; de[1]->energy = ee2[1]; de[2]->energy = ee2[2];
		dv[0]->energy = ev2[0]; dv[1]->energy = ev2[1]; dv[2]->energy = ev2[2];

		//	std::cout << "end 1" << std::endl;
		return energy_2 - energy_1;
	}
	float remove_if_energy_good(const typename Triangulation_base::Vertex_handle& vertex_to_remove, const double& threshold_delta_energy, const double& specific_th_bd)
	{
		//return 0.0f;
		for (auto it(this->finite_faces_begin()), it_end(this->finite_faces_end()); it != it_end; ++it)
		{
			const typename Triangulation_base::Vertex_handle::value_type::Point pt1 = this->dual(it);
			for (int kkk = 0; kkk < 3; ++kkk)
			{
				const typename Triangulation_base::Vertex_handle::value_type::Point pt2 = this->dual(it->neighbor(kkk));
				if (pt2 == pt1)
				{
					std::cout << "rm: bad triangulation " << std::endl;
				}
			}
		}
	//	std::cout << "ini " << list_of_curve.size() << std::endl;

		//remove_and_give_new_face
		std::list<typename Triangulation_base::Face_handle> lst;
		std::set<typename Triangulation_base::Vertex_handle> set_vh;
		std::set<int> set_vh_to_delete_edge;
		std::map<Mon_edge, std::pair<typename Triangulation_base::Face_handle, int>> set_edge;
		int id_vertex_to_remove = vertex_to_remove->info();
	//	data data_vertex_to_remove = vertex_data[id_vertex_to_remove];
		std::map<Mon_edge, int> to_restore_data_face;
	//	std::map<Mon_edge, data> to_restore_data_edge;
		

		////****************************************************************************************************new (swap with line commented after)
		typename Triangulation_base::Face_circulator c = vertex_to_remove->incident_faces();
		typename Triangulation_base::Face_circulator c_end = c;
		do
		{
			lst.emplace_back(c);
			const int i1 = c->vertex(0)->info();
			const int i2 = c->vertex(1)->info();
			const int i3 = c->vertex(2)->info();
			if (edge_data.find(Mon_edge(i2, i3)) == edge_data.end())
				std::cout << "unknown edge 1" << std::endl;
			if (edge_data.find(Mon_edge(i1, i3)) == edge_data.end())
				std::cout << "unknown edge 2" << std::endl;
			if (edge_data.find(Mon_edge(i2, i1)) == edge_data.end())
				std::cout << "unknown edge 3" << std::endl;
			if (i1 == id_vertex_to_remove)
				to_restore_data_face.emplace(Mon_edge(i2, i3), c->info());
			else if (i2 == id_vertex_to_remove)
				to_restore_data_face.emplace(Mon_edge(i1, i3), c->info());
			else if (i3 == id_vertex_to_remove)
				to_restore_data_face.emplace(Mon_edge(i2, i1), c->info());
		} while (++c != c_end);
		//elem_around_ptr(vertex_to_remove->incident_faces(), [&lst,&to_restore_data_face,&id_vertex_to_remove](decltype(vertex_to_remove->incident_faces()) f)
		//{
		//	lst.emplace_back(f);
		//	const int i1 = f->vertex(0)->info();
		//	const int i2 = f->vertex(1)->info();
		//	const int i3 = f->vertex(2)->info();
		//	if (i1 == id_vertex_to_remove)
		//		to_restore_data_face.emplace(Mon_edge(i2, i3), f->info());
		//	else if (i2 == id_vertex_to_remove)
		//		to_restore_data_face.emplace(Mon_edge(i1, i3), f->info());
		//	else if (i3 == id_vertex_to_remove)
		//		to_restore_data_face.emplace(Mon_edge(i2, i1), f->info());
		//});
		//elem_around_ptr(vertex_to_remove->incident_faces(), [&lst, &to_restore_data_face, &id_vertex_to_remove](decltype(vertex_to_remove->incident_vertices()) v)
		//{
		//	to_restore_data_edge.emplace(Mon_edge(v->info(), id_vertex_to_remove);
		//});

		data<Label> data_vertex_to_rm = vertex_data[vertex_to_remove->info()];


		float energy_with = 0;
		for (typename Triangulation_base::Face_handle f : lst)
		{
			energy_with += face_data[f->info()].energy;
			const typename Triangulation_base::Vertex_handle v1 = f->vertex(0);
			const typename Triangulation_base::Vertex_handle v2 = f->vertex(1);
			const typename Triangulation_base::Vertex_handle v3 = f->vertex(2);
			if (v1 != nullptr && !Triangulation_base::is_infinite(v1))
				set_vh.emplace(v1);
			if (v2 != nullptr && !Triangulation_base::is_infinite(v2))
				set_vh.emplace(v2);
			if (v3 != nullptr && !Triangulation_base::is_infinite(v3))
				set_vh.emplace(v3);
		}
		if(set_vh.size() > lst.size() + 1)
		{
			std::cout << "ERROR: vertex handle generate duplicate vertex ptr in set ... " << set_vh.size() << " " << lst.size()<< std::endl;
			std::getc(stdin);
		}
		for (typename Triangulation_base::Vertex_handle v : set_vh)
			if (&*v != &*vertex_to_remove)
				set_vh_to_delete_edge.emplace(v->info());
		fill_edge_in_faces(lst, set_edge);
		for (typename Triangulation_base::Vertex_handle v : set_vh)
			energy_with += vertex_data[v->info()].energy;
		for (auto& p : set_edge)
			energy_with += edge_data[p.first].energy;
		energy_with = 0;
		for (typename Triangulation_base::Face_handle f : lst)
		{
			float& energy = face_data[f->info()].energy;
			energy = Cost_faces::cost(*this, *f);
			energy_with += energy;
		}
		for (typename Triangulation_base::Vertex_handle v : set_vh)
		{
			float& energy = vertex_data[v->info()].energy;
			energy = Cost_vertices::cost(*this, *v);
			energy_with += energy;
		}
		for (auto& p : set_edge)
		{
			float& energy = edge_data[p.first].energy;
			energy = Cost_edges::cost(*this, p.second);
			energy_with += energy;
		}

		float energy_without = 0;
		const typename Triangulation_base::Point point = vertex_to_remove->point();


#ifdef USE_LABEL_SKETCH_BE
		std::map<int, std::list<std::pair<Mon_edge,std::pair<typename Triangulation::Point, typename Triangulation::Point>>>> to_restore;
		std::map<int, double> energy_curve;
		for (typename Triangulation_base::Vertex_handle v : set_vh)
		{
			if (&*v == &*vertex_to_remove)
				continue;
			Mon_edge mon_edge = Mon_edge(v->info(), id_vertex_to_remove);
			if (edge_data.find(mon_edge) == edge_data.end())
				std::cout << "unknown edge" << std::endl;
			if (edge_data[mon_edge].label == 0)
				continue;
			std::set<int>& lst_curve = edge_data[mon_edge].set_of_curve;
	//		std::cout << lst_curve.size() << " " << v->info() << " " << id_vertex_to_remove << " ";
			if (lst_curve.size() == 0)
			{
				std::set<Triangulation_base::Point> circle_center;
				//maybe square ...
				for (typename Triangulation_base::Face_handle f : lst)
				{
					const typename Triangulation_base::Vertex_handle v1 = f->vertex(0);
					const typename Triangulation_base::Vertex_handle v2 = f->vertex(1);
					const typename Triangulation_base::Vertex_handle v3 = f->vertex(2);
					if (v1 == v || v2 == v || v3 == v)
					{
						circle_center.emplace(this->dual(f));
					}
				}
				std::cout << std::endl;
				std::cout << std::endl;
				for (const typename Triangulation_base::Point& pt : circle_center)
					std::cout << pt.x() << " " << pt.y() << std::endl;
				std::getc(stdin);
			}
			
			
			for (const int& id_curve : lst_curve)
			{
		//		std::cout << id_curve << " ";
				auto& ls_ce = list_of_curve[id_curve].set_of_edge;
				std::pair<typename Triangulation::Point, typename Triangulation::Point>& lc_se_point = ls_ce[mon_edge];
				//std::set<std::list<std::pair<typename Triangulation::Vertex*, typename Triangulation::Vertex*>>::iterator> to_rm;
				
				if (to_restore.find(id_curve) == to_restore.end())
					to_restore.emplace(id_curve, std::list<std::pair<Mon_edge, std::pair<typename Triangulation::Point, typename Triangulation::Point>>>());
				to_restore[id_curve].emplace_back(std::make_pair(mon_edge, lc_se_point));
				if (energy_curve.find(id_curve) == energy_curve.end())
					energy_curve.emplace(id_curve, list_of_curve[id_curve].energy(*this));
				ls_ce.erase(ls_ce.find(mon_edge));
			}
		}
		for (const auto& a : energy_curve)
		{
			energy_with += a.second;
			list_of_curve[a.first].fit_curve(*this);
			energy_without += list_of_curve[a.first].energy(*this);
		}
#endif

	//	int base_face_label = 0;
	//	int count_label = 0;
	//	for (typename Triangulation_base::Face_handle f : lst)
	//		if (f->info())
	//			++count_label;
	//	if (count_label > lst.size() / 2)
	//		base_face_label = 1;

		std::set<int> id_faces_to_remove_1;
		std::set<int> id_faces_to_remove_2;
		std::list<int> id_faces_to_remove_intersection;
		for (typename Triangulation_base::Face_handle f : lst)
			id_faces_to_remove_1.emplace(f->info());
	//	if (id_faces_to_remove_1.size() != lst.size())
	//	{
	//		std::cout << "strange " << __LINE__ << " " << __FILE__ << std::endl;
	//		std::cout << "A: ";
	//		for (auto iii : lst)
	//			std::cout << iii->info() << " ";
	//		std::cout << std::endl;
	//		std::cout << "B: ";
	//		for (int iii : id_faces_to_remove_1)
	//			std::cout << iii << " ";
	//		std::cout << std::endl;
	//	}


		std::size_t nb_faces = lst.size();
		lst.clear();
//		Triangulation_base::remove_and_give_new_faces(vertex_to_remove, std::inserter<std::list<typename Triangulation_base::Face_handle>>(lst, lst.begin()));
		Triangulation_base::remove(vertex_to_remove);// , std::inserter<std::list<typename Triangulation_base::Face_handle>>(lst, lst.begin()));
		const typename Triangulation_base::Face_handle& face = Triangulation_base::locate(point);
		Triangulation_base::get_conflicts(point, std::inserter<std::list<typename Triangulation_base::Face_handle>>(lst, lst.begin()), face);
//		if (lst.size() + 2 != nb_faces)
//			std::cout << "bad hp on remove behaviour " << __LINE__ << " " << __FILE__ << std::endl;
		//Triangulation_base::remove(vertex_to_remove);// , std::inserter<std::list<typename Triangulation_base::Face_handle>>(lst, lst.begin()));
		//for (typename Triangulation_base::Face_handle f : lst)
		//	if (f->info() != -1)
		//		id_faces_to_remove_intersection.emplace(f->info());
		//	id_faces_to_remove_2.emplace(f->info());
		std::set<int> lst_id_to_sort;
		for (typename Triangulation_base::Face_handle f : lst)
			lst_id_to_sort.emplace(f->info());

		if (lst_id_to_sort.size() == 1 && lst.front()->info() == -1)
		{//all new face -> append when we remove a vertex with more than 7 incident vertices (ie face ...)
			auto it_1 = id_faces_to_remove_1.begin();
			lst_id_to_sort.clear();
			for (typename Triangulation_base::Face_handle f : lst)
			{
				lst_id_to_sort.emplace(f->info() = *it_1);
				++it_1;
			}
		}
		//std::cout << lst_id_to_sort.size() << std::endl;
		id_faces_to_remove_intersection.resize(lst_id_to_sort.size() + id_faces_to_remove_1.size(), -1);
		auto it_tmp_inter = std::set_difference(id_faces_to_remove_1.begin(), id_faces_to_remove_1.end(), lst_id_to_sort.begin(), lst_id_to_sort.end(), id_faces_to_remove_intersection.begin());
		id_faces_to_remove_intersection.erase(it_tmp_inter, id_faces_to_remove_intersection.end());
//		if (id_faces_to_remove_intersection.size() != 2)
//		{
//			std::cout << "unexcpected behaviour " << id_faces_to_remove_intersection.size() << "    " << __LINE__ << " " << __FILE__ << std::endl;
//
//
//			id_faces_to_remove_intersection.resize(lst_id_to_sort.size() + id_faces_to_remove_1.size(), 0);
//			auto it_tmp_inter = std::set_difference(id_faces_to_remove_1.begin(), id_faces_to_remove_1.end(), lst_id_to_sort.begin(), lst_id_to_sort.end(), id_faces_to_remove_intersection.begin());
//
//			std::cout << "A: ";
//			for (int iii : id_faces_to_remove_intersection)
//				std::cout << iii << " ";
//			std::cout << std::endl;
//			id_faces_to_remove_intersection.erase(it_tmp_inter, id_faces_to_remove_intersection.end());
//
//			std::cout << "B: ";
//			for (int iii : id_faces_to_remove_1)
//				std::cout << iii << " ";
//			std::cout << std::endl;
//			std::cout << "C: ";
//			for (int iii : lst_id_to_sort)
//				std::cout << iii << " ";
//			std::cout << std::endl;
//		}
		//std::cout << lst.size() << std::endl;
		set_vh.erase(set_vh.find(vertex_to_remove));
		set_edge.clear();
		fill_edge_in_faces(lst, set_edge);

		std::map<Mon_edge, data<Label>> edge_data_new;
		std::map<int, data<Label>> vertex_data_new;
		std::map<int, data<Label>> face_data_new;


		for (typename Triangulation_base::Face_handle f : lst)
		{
			data<Label> df;
			int id = f->info();
			df.label = face_data[id].label;
		//	df.color = Cost_faces::recompute_new_color_on_face_cst(*this, *f, df.label);// vertex_data[id].color;
			Cost_faces::p_label(*this, *f, df);
			face_data_new.emplace(f->info(), df);
		}
		for (typename Triangulation_base::Vertex_handle v : set_vh)
		{
			data<Label> dv;
			int id = v->info();
		//	if (id == -1)
		//	{
		//	//	dv.label = label;
		//	//	id_vertex_to_remove.emplace_back(v->info() = new_vertex->info());
		//		std::cout <<"   error on line " << __LINE__ << " on file " << __FILE__ << std::endl;
		//	}
		//	else
				dv.label = vertex_data[id].label;
			Cost_vertices::p_label(*this, *v, dv);
			vertex_data_new.emplace(v->info(), dv);
		}
		std::list<int> id_new_curve;
		int cpt_n = 0;
		for (auto& p : set_edge)
		{
			data<Label> de;
			Mon_edge id = p.first;
			auto it = edge_data.find(id);
			if (it == edge_data.end())
			{
				++cpt_n;
				de.label = Cost_edges::recompute_label<Label>(*this, p.second);

#ifdef USE_LABEL_SKETCH_BE
				if (de.label != 0)
				{
					const auto& v1 = p.second.first->vertex((p.second.second + 1) % 3);
					const auto& v2 = p.second.first->vertex((p.second.second + 2) % 3);
					de.set_of_curve.emplace(curve_next_id);
					list_of_curve.emplace(curve_next_id, curve<Triangulation_base>());
					list_of_curve[curve_next_id].set_of_edge.emplace(id, std::make_pair(v1->point(), v2->point()));
					id_new_curve.emplace_back(curve_next_id);
					list_of_curve[curve_next_id].recompute_parametrization(*this);

					list_of_curve[curve_next_id].fit_curve(*this);
					energy_without += list_of_curve[curve_next_id].energy(*this);
					++curve_next_id;

				}
#endif
			}
			else
			{
				de.label = it->second.label;
				de.set_of_curve = it->second.set_of_curve;
			}
			Cost_edges::p_label(*this, p.second, de);
			edge_data_new.emplace(p.first, de);
		}
		//std::cout << "edn " << cpt_n << std::endl;


		for (typename Triangulation_base::Face_handle f : lst)
		{
			float& energy = face_data_new[f->info()].energy;
			energy = Cost_faces::cost(*this, *f, vertex_data_new, edge_data_new, face_data_new);
			energy_without += energy;
		}
		for (typename Triangulation_base::Vertex_handle v : set_vh)
		{
			float& energy = vertex_data_new[v->info()].energy;
			energy = Cost_vertices::cost(*this, *v, vertex_data_new, edge_data_new, face_data_new);
			energy_without += energy;
		}
		for (auto& p : set_edge)
		{
			float& energy = edge_data_new[p.first].energy;
			energy = Cost_edges::cost(*this, p.second, vertex_data_new, edge_data_new, face_data_new);
			energy_without += energy;
		}
	//	if (id_faces_to_remove_2.size() != 0)
	//		std::cout << "zeutgvzalui " << __LINE__ << " on file " << __FILE__ << std::endl;
		bool is_good_triangulation__ie_unique = true;
		for (auto it(this->finite_faces_begin()), it_end(this->finite_faces_end()); it != it_end; ++it)
		{
			const typename Triangulation_base::Vertex_handle::value_type::Point pt1 = this->dual(it);
			for (int kkk = 0; kkk < 3; ++kkk)
			{
				const typename Triangulation_base::Vertex_handle::value_type::Point pt2 = this->dual(it->neighbor(kkk));
				if (pt2 == pt1)
				{
					std::cout << "bad triangulation: removal rejected" << std::endl;
					is_good_triangulation__ie_unique = false;
				}
			}
		}


		if (energy_without - energy_with - specific_th_bd > threshold_delta_energy || !is_good_triangulation__ie_unique)
		{
			//	remove_edge_cost(new_vertex);
			//est ce que les id des faces sont invariante par l'operateur remove(insert(T))

		//	for (const int& i : id_faces_to_remove_2)
		//		next_info.removed_faces.emplace_back(i);
			lst.clear();
			//Triangulation_base::insert_and_give(point)->info() = id_vertex_to_remove;
			const typename Triangulation_base::Face_handle& face = Triangulation_base::locate(point);
			typename Triangulation_base::Vertex_handle new_vertex_ini = Triangulation_base::insert_and_give_new_faces(point, std::inserter<std::list<typename Triangulation_base::Face_handle>>(lst, lst.begin()), face);
			new_vertex_ini->info() = id_vertex_to_remove;
			//std::cout << new_vertex_ini->info() << std::endl;
			if (std::find(lst.begin(), lst.end(), face) == lst.end())
				lst.emplace_back(face);

#ifdef USE_LABEL_SKETCH_BE
			for (std::pair<const int, std::list<std::pair<Mon_edge, std::pair<typename Triangulation::Point, typename Triangulation::Point>>>>& pp : to_restore)
			{
				auto& lc = list_of_curve[pp.first];
				for(auto& a : pp.second)
					lc.set_of_edge.emplace(a.first, a.second);
				lc.fit_curve(*this);
			}
#endif
#ifdef USE_LABEL_SKETCH_BE
			for (const int& i : id_new_curve)
			{
				list_of_curve.erase(list_of_curve.find(i));
				--curve_next_id;
			}
#endif
		//	std::cout << "revert " << list_of_curve.size() << std::endl;
		//	std::getc(stdin);
			
			lst.clear();
			typename Triangulation_base::Face_circulator c = new_vertex_ini->incident_faces();
			typename Triangulation_base::Face_circulator c_end = c;
			do
			{
				lst.emplace_back(c);
			} while (++c != c_end);
			set_vh.emplace(new_vertex_ini);
			set_edge.clear();
			fill_edge_in_faces(lst, set_edge);

			for (typename Triangulation_base::Face_handle f : lst)
			{
				const int i1 = f->vertex(0)->info();
				const int i2 = f->vertex(1)->info();
				const int i3 = f->vertex(2)->info();
				//if ((i1 == id_vertex_to_remove && f->info() != to_restore_data_face[Mon_edge(i2, i3)])
				//	|| (i2 == id_vertex_to_remove && f->info() != to_restore_data_face[Mon_edge(i1, i3)])
				//	|| (i3 == id_vertex_to_remove && f->info() != to_restore_data_face[Mon_edge(i2, i1)])
				//	)
				//	std::cout << "bad info but we put the right one just after" << std::endl;
				if (i1 == id_vertex_to_remove)
					f->info() = to_restore_data_face[Mon_edge(i2, i3)];
				else if (i2 == id_vertex_to_remove)
					f->info() = to_restore_data_face[Mon_edge(i1, i3)];
				else if (i3 == id_vertex_to_remove)
					f->info() = to_restore_data_face[Mon_edge(i2, i1)];
			}
			vertex_data[vertex_to_remove->info()] = data_vertex_to_rm;
		//	for (auto it(Triangulation_base::finite_vertices_begin()), it_end(Triangulation_base::finite_vertices_end()); it != it_end; ++it)
		//		if (it->info() == -1)
		//			std::cout << "remove bug bug bug : restore vertex info" << __LINE__ << " " << __FILE__ << std::endl;

		//	std::set<int> all_label_face;
		//	int cpt = 0;
		//	for (auto it(Triangulation_base::finite_faces_begin()), it_end(Triangulation_base::finite_faces_end()); it != it_end; ++it)
		//	{
		//		all_label_face.emplace(it->info());
		//		++cpt;
		//	}
		//	if (cpt != all_label_face.size())
		//		std::cout << "error face label remove bad " << __LINE__ << " " << __FILE__ << std::endl;


			//test unicity of label
			float energy_with_2 = 0;
			for (typename Triangulation_base::Face_handle f : lst)
			{
				float& energy = face_data[f->info()].energy;
				energy = Cost_faces::cost(*this, *f);
				energy_with_2 += energy;
			}
			for (typename Triangulation_base::Vertex_handle v : set_vh)
			{
				float& energy = vertex_data[v->info()].energy;
				energy = Cost_vertices::cost(*this, *v);
				energy_with_2 += energy;
			}
			for (auto& p : set_edge)
			{
				float& energy = edge_data[p.first].energy;
				energy = Cost_edges::cost(*this, p.second);
				energy_with_2 += energy;
			}
			if (std::fabs(energy_with - energy_with_2)>0.00001)
			{
	//			std::cout << "rm vertex bad " << energy_with << " " << energy_with_2 << std::endl;
		//		std::getc(stdin);
			}
			return  0.0f;
		}
		else
		{
			//for (const int& i : id_faces_to_remove_1)
			for (const int& i : id_faces_to_remove_intersection)
			{
				next_info.removed_faces.emplace_back(i);
				face_data.erase(i);
			}
			next_info.removed_vertices.emplace_back(id_vertex_to_remove);

			for (const int& t : set_vh_to_delete_edge)
			{
				edge_data.erase(edge_data.find(Mon_edge(t, id_vertex_to_remove)));
			}
		//	std::cout << "erase " << list_of_curve.size()<<" ";
#ifdef USE_LABEL_SKETCH_BE
			for (const std::pair<int,std::list<std::pair<Mon_edge, std::pair<typename Triangulation::Point, typename Triangulation::Point>>>>& pp : to_restore)
			{
				if (list_of_curve[pp.first].set_of_edge.size() == 0)
				{
					list_of_curve.erase(list_of_curve.find(pp.first));
				}
			}
#endif
		//	std::cout << list_of_curve.size() << std::endl;
		//	std::getc(stdin);


			vertex_data.erase(id_vertex_to_remove);

			for (auto& a : edge_data_new)
			{
				auto it = edge_data.find(a.first);
				if (it == edge_data.end())
					edge_data.emplace(a.first, a.second);
				else
					it->second = a.second;
			}
			for (auto& a : vertex_data_new)
			{
				auto it = vertex_data.find(a.first);
				if (it == vertex_data.end())
					vertex_data.emplace(a.first, a.second);
				else
					it->second = a.second;
			}
			for (auto& a : face_data_new)
			{
				auto it = face_data.find(a.first);
				if (it == face_data.end())
					face_data.emplace(a.first, a.second);
				else
					it->second = a.second;
			}



	//		std::set<int> all_label_face;
	//		int cpt = 0;
	//		for (auto it(Triangulation_base::finite_faces_begin()), it_end(Triangulation_base::finite_faces_end()); it != it_end; ++it)
	//		{
	//			all_label_face.emplace(it->info());
	//			++cpt;
	//		}
	//		if (cpt != all_label_face.size())
	//			std::cout << "error face label remove good " << __LINE__ << " " << __FILE__ << std::endl;
	//



			return energy_without - energy_with;
		}


	//	remove_edge_cost(vertex_to_remove);
	//	Triangulation_base::remove(vertex_to_remove);
	//	return insertion_if_energy_good(point,  threshold_delta_energy, true);
	}
	float insertion_if_energy_good(const typename Triangulation_base::Point& point, const int label, const double& threshold_delta_energy, const double& specific_th_bd)
	{
		//return 0.0f;
		Triangulation_base::Locate_type lt;
		int li;
		Triangulation_base::Face_handle fh = Triangulation_base::locate(point, lt, li);
		if (lt == Triangulation::VERTEX)
			return 0.0f;

		//return 0.0f;
		const typename Triangulation_base::Face_handle& face = Triangulation_base::locate(point);
		std::list<typename Triangulation_base::Face_handle> lst;
		std::set<typename Triangulation_base::Vertex_handle> set_vh;
		std::map<Ma_face, int> to_restore_data_face;


	//	std::set<std::pair<const typename Triangulation_base::Vertex*, const typename Triangulation_base::Vertex*>, triangulation_data_structure<Triangulation_data_structure_base>::comparator_vertices_edge> set_edge_v2;

		//std::map<std::pair<const typename Triangulation_base::Vertex*, const typename Triangulation_base::Vertex*>, std::pair<typename Triangulation_base::Face_handle, int>> set_edge;
		std::map<Mon_edge, std::pair<typename Triangulation_base::Face_handle, int>> set_edge;
		std::map<Mon_edge, std::pair<typename Triangulation::Point, typename Triangulation::Point>> set_edge_back;
		Triangulation_base::get_conflicts(point, std::inserter<std::list<typename Triangulation_base::Face_handle>>(lst, lst.begin()), face);
		if (std::find(lst.begin(), lst.end(), face) == lst.end())
			lst.emplace_back(face);


		float energy_without = 0;
		for (typename Triangulation_base::Face_handle f : lst)
		{
			energy_without += face_data[f->info()].energy;
			const typename Triangulation_base::Vertex_handle v1 = f->vertex(0);
			const typename Triangulation_base::Vertex_handle v2 = f->vertex(1);
			const typename Triangulation_base::Vertex_handle v3 = f->vertex(2);
			to_restore_data_face.emplace(Ma_face(v1->info(), v2->info(), v3->info()), f->info());
			if (v1 != nullptr && !Triangulation_base::is_infinite(v1))
				set_vh.emplace(v1);
			if (v2 != nullptr && !Triangulation_base::is_infinite(v2))
				set_vh.emplace(v2);
			if (v3 != nullptr && !Triangulation_base::is_infinite(v3))
				set_vh.emplace(v3);
		}
		fill_edge_in_faces(lst, set_edge);
		for (typename Triangulation_base::Vertex_handle v : set_vh)
			energy_without += vertex_data[v->info()].energy;
		for (auto& p : set_edge)
			energy_without += edge_data[p.first].energy;

		energy_without = 0;
		float u_vertex = 0;
		float u_edge = 0;
		float u_face = 0;
		//std::cout << "uf1 " << std::endl;
		for (typename Triangulation_base::Face_handle f : lst)
		{
			float& energy = face_data[f->info()].energy;
			energy = Cost_faces::cost(*this, *f);
			u_face += energy;
		}
		for (typename Triangulation_base::Vertex_handle v : set_vh)
		{
			float& energy = vertex_data[v->info()].energy;
			energy = Cost_vertices::cost(*this, *v);
			u_vertex += energy;
		}
		for (auto& p : set_edge)
		{
			float& energy = edge_data[p.first].energy;
			energy = Cost_edges::cost(*this, p.second);
			u_edge += energy;
		}

		energy_without = u_vertex + u_edge + u_face;
		const int count_face = (int)lst.size();
		const int count_edge = (int)set_edge.size();
		const int count_vertex = (int)set_vh.size();
	//	for (auto it(Triangulation_base::finite_vertices_begin()), it_end(Triangulation_base::finite_vertices_end()); it != it_end; ++it)
	//		if (it->info() == -1)
	//			std::cout << "bug vertex info " << __LINE__ << " " << __FILE__ << std::endl;
		for(const auto& a : set_edge)
		{
			const auto& v1 = a.second.first->vertex((a.second.second + 1) % 3);
			const auto& v2 = a.second.first->vertex((a.second.second + 2) % 3);
			set_edge_back.emplace(a.first, std::make_pair(v1->point(), v2->point()));
		}
		float energy_with = 0;

		//lst.clear();

		lst.clear();
		typename Triangulation_base::Vertex_handle new_vertex = Triangulation_base::insert_and_give_new_faces(point, std::inserter<std::list<typename Triangulation_base::Face_handle>>(lst, lst.begin()), face);
		bool is_good_triangulation__ie_unique = true;
		typename Triangulation::Face_circulator c = new_vertex->incident_faces();
		typename Triangulation::Face_circulator c_end = c;
		do
		{
			const typename Triangulation::Point pt1 = this->dual(c);
			for (int kkk = 0; kkk < 3; ++kkk)
			{
				const typename Triangulation::Point pt2 = this->dual(c->neighbor(kkk));
				if (pt2 == pt1)
				{
					std::cout << "bad triangulation: insertion rejected" << std::endl;
					is_good_triangulation__ie_unique = false;
				}
			}
		} while (++c != c_end);

		//****new*****
		//****new*****
		//****new*****
		//****new*****
		//****new*****
		//****new*****
		const int nb_new_face_insert = (int)lst.size();
		lst.clear();
		c_end = c = new_vertex->incident_faces();
		do
		{
			lst.emplace_back(c);
		} while (++c != c_end);
		if (lst.size() != nb_new_face_insert)
		{
			std::cout << lst.size() << " " << nb_new_face_insert << std::endl;
			std::getc(stdin);
		}

		//new_vertex->info() = next_info.vertex();
		//add info in new face too (the one with -1 as value

		//new_faces->info() = ...;


		set_edge.clear();
		set_vh.emplace(new_vertex);
		std::map<Mon_edge, data<Label>> edge_data_new;
		std::map<int, data<Label>> vertex_data_new;
		std::map<int, data<Label>> face_data_new;

		Label base_face_label = face_data[face->info()].label;
		std::list<int> id_face_to_remove;
		std::list<int> id_vertex_to_remove;
	//	id_vertex_to_remove.emplace_back(new_vertex->info());
		for (typename Triangulation_base::Face_handle f : lst)
		{
			data<Label> df;
			int id = f->info();
			if (id == -1)
			{
			//	if (f->vertex(0)->info() < 4 || f->vertex(1)->info() < 4 || f->vertex(2)->info() < 4)
			//		df.label = 0;
			//	else
					df.label = base_face_label;
				id_face_to_remove.emplace_back(f->info() = next_info.face());
			}
			//else if (f->vertex(0)->info() < 4 || f->vertex(1)->info() < 4 || f->vertex(2)->info() < 4)
			//	df.label = 0;
			else
				df.label = face_data[id].label;
		//	df.color = Cost_faces::recompute_new_color_on_face_cst(*this, *f, df.label);
			Cost_faces::p_label(*this, *f, df);
			face_data_new.emplace(f->info(), df);
		}
		for (typename Triangulation_base::Vertex_handle v : set_vh)
		{
			data<Label> dv;
			int id = v->info();
			if (id == -1)
			{
				dv.label = Cost_vertices::recompute_label<Label>(*this, *v);// , dv.label);// vertex_data[id].color;
				id_vertex_to_remove.emplace_back(v->info() = next_info.vertex());
			//	Cost_vertices::recompute_label(*this, *v).first;
				//std::cout <<_"   error on line " << __LINE__ << " on file " << __FILE__ << std::endl;
			}
			else
			{
				dv.label = vertex_data[id].label;
			}
			Cost_vertices::p_label(*this, *v, dv);
			vertex_data_new.emplace(v->info(), dv);
		}
		fill_edge_in_faces(lst, set_edge);
		std::map<Mon_edge, std::pair<typename Triangulation::Point, typename Triangulation::Point>> set_edge_lost;
		for (const auto& p : set_edge_back)
		{
			if (set_edge.find(p.first) == set_edge.end())
				set_edge_lost.emplace(p);
			//***********************************************************************************************************************
		}
		//std::cout << set_edge_lost.size() << std::endl;;
		//std::getc(stdin);

#ifdef USE_LABEL_SKETCH_BE
		std::map<int, std::list<std::pair<Mon_edge, std::pair<typename Triangulation::Point, typename Triangulation::Point>>>> to_restore;
		std::map<int, double> energy_curve;
		for (const auto& a : set_edge_lost)
		{
			const auto& p1 = a.second.first;
			const auto& p2 = a.second.second;
			if (edge_data[a.first].label == 0)
				continue;
			std::set<int>& lst_curve = edge_data[a.first].set_of_curve;
			if (lst_curve.size() == 0)
			{
				std::cout << "bug" << std::endl;
				std::getc(stdin);
			}
			for (const int& id_curve : lst_curve)
			{
				auto& lc_se = list_of_curve[id_curve].set_of_edge;
				std::pair<typename Triangulation::Point, typename Triangulation::Point>& lc_se_point = lc_se[a.first];
				if (to_restore.find(id_curve) == to_restore.end())
					to_restore.emplace(id_curve, std::list<std::pair<Mon_edge, std::pair<typename Triangulation::Point, typename Triangulation::Point>>>());
				to_restore[id_curve].emplace_back(a.first, lc_se_point);
				if (energy_curve.find(id_curve) == energy_curve.end())
					energy_curve.emplace(id_curve, list_of_curve[id_curve].energy(*this));
				lc_se.erase(lc_se.find(a.first));
			}
		}
		for (const auto& a : energy_curve)
		{
			energy_without += a.second;
			list_of_curve[a.first].fit_curve(*this);
			energy_with += list_of_curve[a.first].energy(*this);
		}
#endif
	//	for (auto it(Triangulation_base::finite_vertices_begin()), it_end(Triangulation_base::finite_vertices_end()); it != it_end; ++it)
	//		if (it->info() == -1)
	//			std::cout << "bug vertex info " << __LINE__ << " " << __FILE__ << std::endl;
		std::list<int> id_new_curve;
		for (auto& p : set_edge)
		{
			data<Label> de;
			Mon_edge id = p.first;
			auto it = edge_data.find(id);
			if (it == edge_data.end())
			{
				de.label = Cost_edges::recompute_label<Label>(*this, p.second);

#ifdef USE_LABEL_SKETCH_BE
				if (de.label != 0)
				{
					const auto& v1 = p.second.first->vertex((p.second.second + 1) % 3);
					const auto& v2 = p.second.first->vertex((p.second.second + 2) % 3);
					de.set_of_curve.emplace(curve_next_id);
					list_of_curve.emplace(curve_next_id, curve<Triangulation_base>());
					list_of_curve[curve_next_id].set_of_edge.emplace(id, std::make_pair(v1->point(), v2->point()));
					id_new_curve.emplace_back(curve_next_id);
					list_of_curve[curve_next_id].recompute_parametrization(*this);
					list_of_curve[curve_next_id].fit_curve(*this);
					energy_with += list_of_curve[curve_next_id].energy(*this);
					++curve_next_id;
				}
#endif
			}
			else
			{
				de.label = it->second.label;
				de.set_of_curve = it->second.set_of_curve;
			}
		//	de.p_label = Cost_edges::proba_border(p.second);
			Cost_edges::p_label(*this, p.second, de);

			edge_data_new.emplace(p.first, de);
		}

	//	std::cout << "uf2 " << std::endl;

		for (typename Triangulation_base::Face_handle f : lst)
		{
			float& energy = face_data_new[f->info()].energy;
			energy = Cost_faces::cost(*this, *f, vertex_data_new, edge_data_new, face_data_new);
			energy_with += energy;
		}
		for (typename Triangulation_base::Vertex_handle v : set_vh)
		{
			float& energy = vertex_data_new[v->info()].energy;
			energy = Cost_vertices::cost(*this, *v, vertex_data_new, edge_data_new, face_data_new);
			energy_with += energy;
		}
		for (auto& p : set_edge)
		{
			float& energy = edge_data_new[p.first].energy;
			energy = Cost_edges::cost(*this, p.second, vertex_data_new, edge_data_new, face_data_new);
			energy_with += energy;
		}



			if (energy_with - energy_without - specific_th_bd> threshold_delta_energy || !is_good_triangulation__ie_unique)
			{
			//	remove_edge_cost(new_vertex);
				//est ce que les id des faces sont invariante par l'operateur remove(insert(T))
				

#ifdef USE_LABEL_SKETCH_BE
				for ( std::pair<const int, std::list<std::pair<Mon_edge,std::pair< typename Triangulation::Point, typename Triangulation::Point>>>>& pp : to_restore)
				{
					auto& lc = list_of_curve[pp.first];
					for (auto& a : pp.second)
						lc.set_of_edge.emplace(a.first, a.second);
					lc.fit_curve(*this);
				}
#endif
#ifdef USE_LABEL_SKETCH_BE
				for (const int& i : id_new_curve)
				{
					list_of_curve.erase(list_of_curve.find(i));
					--curve_next_id;
				}
#endif


				for (const int& i : id_vertex_to_remove)
					next_info.removed_vertices.emplace_back(i);
				for (const int& i : id_face_to_remove)
					next_info.removed_faces.emplace_back(i);


				Triangulation_base::remove(new_vertex);
				
				lst.clear();
				const typename Triangulation_base::Face_handle& face2 = Triangulation_base::locate(point);
				Triangulation_base::get_conflicts(point, std::inserter<std::list<typename Triangulation_base::Face_handle>>(lst, lst.begin()), face2);
				if (std::find(lst.begin(), lst.end(), face2) == lst.end())
					lst.emplace_back(face2);
				for (typename Triangulation_base::Face_handle f : lst)
				{
					const int i1 = f->vertex(0)->info();
					const int i2 = f->vertex(1)->info();
					const int i3 = f->vertex(2)->info();
					//if ( f->info() != to_restore_data_face[Ma_face(i1, i2, i3)])
					//	std::cout << "bad info but we put the right one just after  " << f->info() << std::endl;
					if(to_restore_data_face.find(Ma_face(i1, i2, i3))== to_restore_data_face.end())
						std::cout << "bbbbuuuuuuuuuuuuuugggggggg  myybe because of non unicity of delaunay triangulation" << __LINE__ << " " << __FILE__ << std::endl;
					f->info() = to_restore_data_face[Ma_face(i1, i2, i3)];
				}


				set_vh.erase(new_vertex);
				set_edge.clear();
				fill_edge_in_faces(lst, set_edge);
				float energy_without_2 = 0;
				float u_vertex_2 = 0;
				float u_edge_2 = 0;
				float u_face_2 = 0;
				float u_face_3 = 0;
	//			std::cout << "uf3 " << std::endl;
				for (typename Triangulation_base::Face_handle f : lst)
				{
					float& energy = face_data[f->info()].energy;
					energy = Cost_faces::cost(*this, *f);
					u_face_2 += energy;
				}
				//for (typename Triangulation_base::Face_handle f : lst){
				//	u_face_3 += Cost_faces::cost(*this, *f);
				//}
				for (typename Triangulation_base::Vertex_handle v : set_vh)
				{
					float& energy = vertex_data[v->info()].energy;
					energy = Cost_vertices::cost(*this, *v);
					u_vertex_2 += energy;
				}
				for (auto& p : set_edge)
				{
					float& energy = edge_data[p.first].energy;
					energy = Cost_edges::cost(*this, p.second);
					u_edge_2 += energy;
				}
				energy_without_2 = u_vertex_2 + u_edge_2 + u_face_2;



				//for (auto& p : set_edge)
				//{
				//	float pl1 = edge_data[p.first].p_label;
				//	float pl2 = Cost_edges::p_label(*this, p.second, edge_data[p.first].label);
				//	if (pl1!= pl2)
				//	{
				//		std::cout << "insert p_label " << pl1 << " " << pl2 << " " << p.first.id_edge << std::endl;
				//		std::getc(stdin);
				//	}
				//}
				//
				//
				//if (std::fabs(energy_without - energy_without_2)>0.00001)
				//{
				//	if (lst.size() != count_face)
				//		std::cout << "bad face size " << lst.size() << " " << count_face << std::endl;
				//
				//	if (set_edge.size() != count_edge)
				//		std::cout << "bad edge size " << set_edge.size() << " " << count_edge << std::endl;
				//
				//	if (set_vh.size() != count_vertex)
				//		std::cout << "bad vertex size " << set_vh.size() << " " << count_vertex << std::endl;
				//	if (u_vertex != u_vertex_2)
				//		std::cout << "bad vertex u " << u_vertex << " " << u_vertex_2 << std::endl;
				//	if (u_edge != u_edge_2)
				//		std::cout << "bad edge u " << u_edge << " " << u_edge_2 << std::endl;
				//	if (u_face != u_face_2)
				//		std::cout << "bad face u " << u_face << " " << u_face_2 << std::endl;
				//
				//	std::cout << "add vertex bad " << energy_without << " " << energy_without_2 << std::endl;
				//	std::getc(stdin);
				//}
				//else
				//	std::cout << "add vertex good" << std::endl;



				return  0.0f;
			}
			else
			{
				//	std::cout << "erase " << list_of_curve.size()<<" "<<to_restore.size() << " ";

				
#ifdef USE_LABEL_SKETCH_BE
				for (const std::pair<int, std::list<std::pair<Mon_edge, std::pair<typename Triangulation::Point, typename Triangulation::Point>>>>& pp : to_restore)
				{
					if (list_of_curve[pp.first].set_of_edge.size() == 0)
					{
						list_of_curve.erase(list_of_curve.find(pp.first));
					}
				}
#endif
			//	std::cout << list_of_curve.size() << std::endl;
			//	std::getc(stdin);
				for (const auto& a : set_edge_lost)
					edge_data.erase(edge_data.find(a.first));

				
				for (auto& a : edge_data_new)
				{
					auto it = edge_data.find(a.first);
					if (it == edge_data.end())
						edge_data.emplace(a.first, a.second);
					else
						it->second = a.second;
				}
				for (auto& a : vertex_data_new)
				{
					auto it = vertex_data.find(a.first);
					if (it == vertex_data.end())
						vertex_data.emplace(a.first, a.second);
					else
						it->second = a.second;
				}
				for (auto& a : face_data_new)
				{
					auto it = face_data.find(a.first);
					if (it == face_data.end())
						face_data.emplace(a.first, a.second);
					else
						it->second = a.second;
				}
				return energy_with - energy_without;
			}
	}
};


#endif

