#pragma once
#include"Texture.hpp"
#include"texture_loader.h"
class Texture_fbo
{
	private:
		std::shared_ptr<Texture> texture;
		GLuint attachment_type;
	public:
		Texture_fbo(std::shared_ptr<Texture> _texture, const GLuint& attach_type)
			:texture(_texture),attachment_type(attach_type)
		{
		}
		void attach(const GLuint& mode)
		{
			//std::cout << "attach "<< attachment_type<<std::endl;
			//glFramebufferTexture(mode, attachment_type, texture->getTextureType(),0);
			glFramebufferTexture2D(mode, attachment_type, GL_TEXTURE_2D,texture->getTextureId(),0);
			//std::cout << "attach done"<<std::endl;
		}
		void save(const char* name)
		{
			//dynamic_cast<base_texture*>(texture.get())->save_texture(name);
			texture.get()->download_texture(name);
		}

		void resize(int width, int height)
		{
			texture->resize(width, height);
		}
};



