#ifndef __Texture_QT_HEADER__
#define __Texture_QT_HEADER__

#include"Texture.hpp"
#include <opencv2/core/core.hpp>
//#include<QtOpenGL/QtOpenGL>

class Texture_opencv : public base_texture
{
protected:
public:
	virtual bool loadTexture(const std::string &path);
	bool loadTexture(const cv::Mat_<float> &src);
	bool loadTexture(const cv::Mat_<cv::Vec3f> &src);
	void update_texture(const cv::Mat_<float> &src);
	void update_texture(const cv::Mat_<cv::Vec3f> &src);
	virtual bool save_texture(const std::string& name, unsigned char* data, const int& w, const int& h);
	static bool save_data(const std::string& name, unsigned char* data, const int& w, const int& h);
	static bool save_data_mono(const std::string& name, unsigned char* data, const int& w, const int& h);
	Texture_opencv();
	Texture_opencv(const cv::Mat_<float>& mat_f);
	Texture_opencv(const cv::Mat_<cv::Vec3f>& mat_f);
	Texture_opencv(const std::string& path);
	Texture_opencv(const GLuint id);
	Texture_opencv(const glm::vec2& size);


	virtual ~Texture_opencv();

};

#endif
