#pragma once
#ifndef MON_FICHIER_UTIL_HEADER
#define MON_FICHIER_UTIL_HEADER

#define _USE_MATH_DEFINES
#include<cmath>

#ifdef WIN32
 #include <windows.h>
#endif

#define _ITER_BE_(x) std::begin(x), std::end(x)
#define _ITER_C_BE_(x) std::cbegin(x), std::cend(x)
#define _ITER_CR_BE_(x) std::crbegin(x), std::crend(x)
#define _ITER_R_BE_(x) std::rbegin(x), std::rend(x)

#define _ITER_T_(x) decltype(*std::begin(x))&
#define _ITER_C_T_(x) decltype(*std::cbegin(x))&
#define _ITER_CR_T_(x) decltype(*std::crbegin(x)&
#define _ITER_R_T_(x) decltype(*std::rbegin(x))&

#define _ITER_VAR_1_(x, a1) _ITER_T_(x) a1
#define _ITER_C_VAR_1_(x, a1) _ITER_C_T_(x) a1
#define _ITER_CR_VAR_1_(x, a1) _ITER_CR_T_(x) a1
#define _ITER_R_VAR_1_(x, a1) _ITER_R_T_(x) a1

#define _ITER_VAR_2_(x, a1, a2) _ITER_T_(x) a1, _ITER_T_(x) a2
#define _ITER_C_VAR_2_(x, a1, a2) _ITER_C_T_(x) a1, _ITER_C_T_(x) a2
#define _ITER_CR_VAR_2_(x, a1, a2) _ITER_CR_T_(x) a1, _ITER_CR_T_(x) a2
#define _ITER_R_VAR_2_(x, a1, a2) _ITER_R_T_(x) a1, _ITER_R_T_(x) a2
//
//template<typename T, typename... V, template<typename, typename...> class U>
//auto find_exists(const U<T, V...>& collection) -> decltype(U<T, V...>::find, void());
//
//
//template<typename T, typename... V, template<typename, typename...> class U>
//inline bool find(const T& element, const U<T, V...>& collection)
//{
//	find_exists(collection);
//	return std::find(_ITER_C_BE_(collection), element) != std::cend(collection);
//}
//template<typename T, typename... V, template<typename, typename...> class U>
//inline bool find_2(const T& element, const U<T, V...>& collection)
//{
//	return collection.find(element) != std::cend(collection);
//}
#include<GL/glew.h>
#include<GL/glext.h>
#include<GL/gl.h>

#define GLM_FORCE_RADIANS
//#define GLM_SWIZZLE
//#define GLM_FORCE_SSE2
//#define GLM_FORCE_AVX
//#define GLM_FORCE_INLINE
#include<glm/glm.hpp>
#include<glm/ext.hpp>

#define BUFFER_OFFSET(i)   ((char *)NULL + (i))


#include<iostream>
#include<fstream>
#include<sstream>

#include<cstring>//for memcpy
#include<string>

#include<vector>
#include<list>
#include<map>
#include<array>
//#include<experimental/dynarray>
#include<stack>
#include<queue>
#include<set>
#include<tuple>
#include<unordered_set>
#include<unordered_map>
#include<random>
#include<memory>
#include<type_traits>
#include<algorithm>
#include<functional>

	
#define END_PROG \
	std::cout << "Press Enter to end ...";\
    getc(stdin);\
	return EXIT_SUCCESS;

//#define foreach(x,y) std::for_each(begin(x),end(x),y)

//for connection on the sketch
#define SEUILLAGE_DISTANCE_CONNECTION_SQUARED (0.01f*0.01f)
	

class less_vec4
{
public:
	bool operator()(const glm::vec4& a, const glm::vec4& z)const
	{
		return a.x<z.x || (a.x == z.x&&a.y<z.y) || (a.x == z.x&&a.y == z.y&&a.z<z.z) || (a.x == z.x&&a.y == z.y&&a.z==z.z&&a.w<z.w);
	}
};
class less_vec3
{
public:
	bool operator()(const glm::vec3& a, const glm::vec3& z)const
	{
		return a.x<z.x || (a.x == z.x&&a.y<z.y) || (a.x == z.x&&a.y == z.y&&a.z<z.z);
	}
};
class less_vec2
{
public:
	bool operator()(const glm::vec2& a, const glm::vec2& z)const
	{
		return a.x<z.x||(a.x==z.x&&a.y<z.y);
	}
};
class less_ivec2
{
public:
	bool operator()(const glm::ivec2& a, const glm::ivec2& z)const
	{
		return a.x<z.x || (a.x == z.x&&a.y<z.y);
	}
};
inline std::istream& operator>>(std::istream& is, glm::ivec2& v)
{
	is >> v.x >> v.y;
	return is;
}
inline std::ostream& operator<<(std::ostream& os, const glm::ivec2& v)
{
	os << v.x << ' ' << v.y;
	return os;
}
inline std::istream& operator>>(std::istream& is, glm::vec2& v)
{
	is >> v.x >> v.y;
	return is;
}
inline std::ostream& operator<<(std::ostream& os, const glm::vec2& v)
{
	os << v.x << ' ' << v.y;
	return os;
}
inline std::istream& operator>>(std::istream& is, glm::vec3& v)
{
	is >> v.x >> v.y >> v.z;
	return is;
}
inline std::ostream& operator<<(std::ostream& os, const glm::vec3& v)
{
	os << v.x << ' ' << v.y << ' ' << v.z;
	return os;
}

template<typename T>
typename T::value_type average(T ini, T end)
{
	typename T::value_type tmp;
	tmp *= 0;
	const typename T::difference_type& nb_elem = std::distance(ini, end);
	for (; ini != end; ++ini)
	{
		tmp += *ini;
	}
	return tmp*(1.0 / nb_elem);
}


template<typename T, typename... V, template<typename, typename...> class U>
inline bool find(const T& element, const U<T, V...>& collection)
{
	//std::cout << "default" << std::endl;
	return std::find(_ITER_C_BE_(collection), element) != std::cend(collection);
}
template<typename T, typename... V>
inline bool find(const T& element, const std::set<T, V...>& collection)
{
	//std::cout << "set" << std::endl;
	return collection.find(element) != std::cend(collection);
}
template<typename T, typename... V>
inline bool find(const T& element, const std::multiset<T, V...>& collection)
{
	return collection.find(element) != std::cend(collection);
}
template<typename T, typename... V>
inline bool find(const T& element, const std::map<T, V...>& collection)
{
	//std::cout << "map" << std::endl;
	return collection.find(element) != std::cend(collection);
}
template<typename T, typename... V>
inline bool find(const T& element, const std::multimap<T, V...>& collection)
{
	return collection.find(element) != std::cend(collection);
}
template<typename T, typename... V>
inline bool find(const T& element, const std::unordered_set<T, V...>& collection)
{
	return collection.find(element) != std::cend(collection);
}
template<typename T, typename... V>
inline bool find(const T& element, const std::unordered_multiset<T, V...>& collection)
{
	return collection.find(element) != std::cend(collection);
}
template<typename T, typename... V>
inline bool find(const T& element, const std::unordered_map<T, V...>& collection)
{
	return collection.find(element) != std::cend(collection);
}
template<typename T, typename... V>
inline bool find(const T& element, const std::unordered_multimap<T, V...>& collection)
{
	return collection.find(element) != std::cend(collection);
}

template<typename T, typename E, typename Fn>
T dico(T t_base_0, T t_base_1, E& erreur, Fn fn)
{
	//typedef decltype(fn(t_base_0)) E;
	T t_left = t_base_0, t_right = t_base_1;
	T t_middle = T(0.5)*(t_base_0 + t_base_1);
	T t_left_middle = T(0.5)*(t_base_0 + t_middle);
	T t_right_middle = T(0.5)*(t_base_1 + t_middle);

	E error_middle = fn(t_middle);
	E error_left, error_right;
	int max_iter = 100;
	int iter = 0;
	do
	{
		error_left = fn(t_left_middle);
		error_right = fn(t_right_middle);
	//	std::cout << error_left << " " << error_right << std::endl;
		if (error_left + 0.01 < error_right && error_left + 0.01 < error_middle)
			//if (std::fabs(error_left - error_right) < 0.001 && std::fabs(error_left - error_middle) < 0.001)
		{
			t_right = t_middle;
			t_middle = t_left_middle;
			error_middle = error_left;
		}
		else if (error_middle + 0.01 < error_right && error_middle + 0.01 < error_left)
			//else if (std::fabs(error_middle - error_right) < 0.001 && std::fabs(error_middle - error_left) < 0.001)
		{
			t_right = t_right_middle;
			t_left = t_left_middle;
		}
		else if (error_right + 0.01 < error_middle && error_right + 0.01 < error_left)
			//else if (std::fabs(error_left - error_right) < 0.001 && std::fabs(error_left - error_middle) < 0.001)
		{
			t_left = t_middle;
			t_middle = t_right_middle;
			error_middle = error_right;
		}
		else
		{
			break;//2 are equals
		}
	//	std::cout << "no break" << std::endl;
		t_left_middle = (t_left + t_middle)*T(0.5);
		t_right_middle = (t_right + t_middle)*T(0.5);
		++iter;
	} while (iter < max_iter);// t_left_middle>0.1 && t_right_middle < 0.9);
	erreur = error_middle;
	return t_middle;
}
#endif


