#pragma once
#ifndef MESH__HEADER
#define MESH__HEADER
#include "object.h"


class mesh : public base_object<mesh>
{
private:
		int size;
public:
//	mesh(int nb_elem = 0) :size(nb_elem){}
	mesh(VAO* vao_ref, int nb_elem = 0) :base_object<mesh>(vao_ref), size(nb_elem){}
	static void ini_shader()
	{
		Shader s;
		s.loadVertexShaderFromFile("shader/shader_mesh.vert");
		s.loadFragmentShaderFromFile("shader/shader_mesh.frag");
		object::map_type_shader.emplace(std::make_pair(std::type_index(typeid(mesh)), std::move(s)));
	}
		inline void draw_2(const glm::mat4& scene)const
		{
			glDrawArrays(GL_TRIANGLES,0,size);
		}
};
class mesh_edge : public base_object<mesh_edge>
{
private:
	int size;
public:
//	mesh_edge(int nb_elem = 0) :size(nb_elem){}
	mesh_edge(VAO* vao_ref, int nb_elem = 0) :base_object<mesh_edge>(vao_ref), size(nb_elem){}
	static void ini_shader()
	{
		Shader s;
		s.loadVertexShaderFromFile("shader/shader_mesh_edge.vert");
		s.loadFragmentShaderFromFile("shader/shader_mesh_edge.frag");
		object::map_type_shader.emplace(std::make_pair(std::type_index(typeid(mesh_edge)), std::move(s)));
	}
	inline void draw_2(const glm::mat4& scene)const
	{
		glDrawArrays(GL_TRIANGLES, 0, size);
	}
};
class mesh_ibo : public base_object<mesh_ibo>
{
private:
		int size;
	public:
		//mesh_ibo(int nb_elem) :size(nb_elem){}
		mesh_ibo(VAO* vao_ref, int nb_elem = 0) :base_object<mesh_ibo>(vao_ref), size(nb_elem){}
		static void ini_shader()
		{
			Shader s;
			s.loadVertexShaderFromFile("shader/shader_mesh_ibo.vert");
			s.loadFragmentShaderFromFile("shader/shader_mesh_ibo.frag");
			object::map_type_shader.emplace(std::make_pair(std::type_index(typeid(mesh_ibo)), std::move(s)));
		}
		inline void draw_2(const glm::mat4& scene)const
		{
			glDrawElements(GL_TRIANGLES,size,GL_UNSIGNED_INT,0);
		}
};

#endif


