#pragma once
#ifndef MAIN_WIDGET_HEADER
#define MAIN_WIDGET_HEADER

#define STANDARD_RANDOM_OPERATOR_SELECTOR
//#define ROBUST_ERROR_BUT_LONG_TIME

//#define USE_LABEL_SKETCH
//#define USE_LABEL_SKETCH_BE
//#define USE_APPLICATION_COMPRESSION
#define USE_APPLICATION_LINE_NETWORK_EXTRACTION
//#define USE_APPLICATION_CONTOURING


#include"util_define.h"
#include"FBO.h"
#include"object.h"
#include"image_tex.h"
#include"gl_bezier.h"
#include<QtWidgets/QWidget>
#include<QtOpenGL/QGLWidget>
#include<QtGui/QMouseEvent>
#include<QtGui/QKeyEvent>
#include<QtGui/QWheelEvent>
#include <QSlider>

class gl_widget;
class q_slider_change_alpha : public QSlider
{
	Q_OBJECT
public:
	static gl_widget* mon_gl_widget;
	float* __alpha;
//	QSlider* slid;
	q_slider_change_alpha(QWidget *parent = nullptr) : QSlider(Qt::Horizontal, parent), __alpha(nullptr)
	{
		QSlider::setMinimum(0);
		QSlider::setMaximum(255);
		QSlider::setValue(255);
	}
	void _connect()
	{
		if (__alpha != nullptr)
			QObject::connect(this, SIGNAL(valueChanged(int)), this, SLOT(on_alpha_change(int)));
	}
	void _connect(float& _ref_to_alpha)
	{
		_connect(&_ref_to_alpha);
	}
	void _connect(float* _ptr_to_alpha)
	{
		QObject::disconnect(this, SIGNAL(valueChanged(int)), this, SLOT(on_alpha_change(int)));
		__alpha = _ptr_to_alpha;
		*__alpha = this->value()*0.00392156862f;
		_connect();
	}
	public slots:
	void on_alpha_change(int val)
	{
		*__alpha = val*0.00392156862f;
		((QGLWidget*)mon_gl_widget)->update();
		((QGLWidget*)mon_gl_widget)->setFocus();
	}

};
class gl_widget : public QGLWidget, public base_object<gl_widget>
{
    Q_OBJECT
public:
	inline void set_t_s()
	{
		for (repere_2d* ptr : obj_2d)
		{
			ptr->s = s;
			ptr->t = t;
		}
	}
	inline glm::vec2 coordinate_window_to_gl_viewport(const glm::vec2& pos)
	{
		return glm::vec2(glm::vec2(m_last_pos.x() *1.0f / viewport.z / s + 0.5 - t.x / 2 - 0.5 / s - viewport.x / viewport.z / s,
			m_last_pos.y() *1.0f / viewport.w / s + 0.5 + t.y / 2 - 0.5 / s - viewport.y / viewport.w / s));
	}
	inline glm::vec2 coordinate_window_to_gl(const glm::vec2& pos)
	{
		return glm::vec2((pos.x*1.0 / width() - 0.5f) / s + 0.5f - 0.5f*t.x,
			(pos.y*1.0 / height() - 0.5f) / s + 0.5f + 0.5*t.y);
	}
	inline glm::vec2 coordinate_gl_to_window(const glm::vec2& pos)
	{
		return glm::vec2(width()*(s * (pos.x - 0.5 + 0.5*t.x) + 0.5),
			height()*(s * (pos.y - 0.5 - 0.5* t.y) + 0.5));
	}
	gl_widget(QWidget* parent = 0);
	virtual ~gl_widget();
	inline void draw_2(const glm::mat4& scene)const
	{

	}
protected:
//main_widget_opengl.cpp
    void initializeGL();
    void resizeGL(int width, int height);
    void paintGL();
	void sub_draw(const glm::mat4& scene);

//main_widget.cpp
public:
	template<typename T>
	Image_tex* ini_img(const cv::Mat_<T>& img, const std::string& obj_name, const float depth);
	gl_triangle_color* gl_widget::ini_triangle_color(const std::string& obj_name, VBO& vbo_to_put_vertices, const float depth, const std::size_t& deg);
	//template<typename Triangulation>
	//std::vector<float*> ini_vbo_graph(Triangulation& triangulation, VBO& vbo_to_put_vertices, const std::string& obj_name, const float depth, const glm::vec3& color_nodes, const std::vector<glm::vec3>& color_edges);
	template<typename T>
	T* ini_bezier_deg(const std::string& obj_name, VBO& vbo_to_put_vertices, const float depth, const glm::vec3& color, const std::size_t& deg);
	template<typename T>
	T* ini_bezier_deg_color(const std::string& obj_name, VBO& vbo_to_put_vertices, const float depth, const std::vector<glm::vec3>& color, const std::size_t& deg);
	void set_input_img(const cv::Mat_<cv::Vec3f>& img);

signals:
void job_end();
void job_end_finish();
public:
public slots:
//main_widget.cpp
	void update();
public slots:
//main_widget_slot_key_mouse_event.cpp
	void mouseMoveEvent(QMouseEvent* event);
	void mousePressEvent(QMouseEvent* event);
	void wheelEvent(QWheelEvent *event);
	void keyReleaseEvent(QKeyEvent * event);
public:
	FBO fbo;
	VBO vbo, vbo_img;
	//std::vector<std::shared_ptr<VBO>> lst_vbo;

	std::vector<q_slider_change_alpha*> v_change_alpha_event;
	int img_rows, img_cols;
	GLfloat m_width;
	GLfloat m_height;
	glm::vec2 real_size,scale_size;
	QPoint m_last_pos;
	glm::vec2 m_last_pos_vec2_in_sketch_coord;
	std::vector<object*> obj;
	std::map<std::string, std::pair<object*,bool>> obj_visibility;
	std::vector<repere_2d*> obj_2d;

	std::set<glm::ivec2, less_ivec2> pixel_label_1;
	std::set<glm::ivec2, less_ivec2> pixel_label_2;

	float ratio;
	float s;
	int s_den;
	glm::vec2 t;

	float coeff_focal;
	
	float w,h;
	glm::vec4 viewport;

};
//template<typename Triangulation>
//std::vector<float*> gl_widget::ini_vbo_graph(Triangulation& triangulation, VBO& vbo_to_put_vertices, const std::string& obj_name, const float depth, const glm::vec3& color_nodes, const std::vector<glm::vec3>& color_edges)
//{
//	std::vector<glm::vec4> vec_data_degb3;
//	std::vector<glm::vec2> vec_data_degb2;
//	std::vector<glm::vec2> vec_data_degb1;
//	std::vector<glm::vec2> vec_data_deg1;
//	std::vector<glm::vec2> vec_data_deg0;
//	std::vector<glm::vec2> vec_data_triangle;
//	std::vector<glm::vec3> color_triangle;
//	std::vector<int> color_edge;
//	
//	vec_data_deg0.reserve(triangulation.number_of_vertices());
//	for (auto it(triangulation.vertices_begin()), it_end(triangulation.vertices_end()); it != it_end; ++it)
//		vec_data_deg0.emplace_back(it->point().x() / img_cols, it->point().y() / img_rows);
//	vec_data_deg1.reserve((triangulation.number_of_faces() + 1 + triangulation.number_of_vertices() - 2) * 2);
//	vec_data_degb1.reserve((triangulation.number_of_faces() + 1 + triangulation.number_of_vertices() - 2) * 2);
//	vec_data_degb2.reserve((triangulation.number_of_faces() + 1 + triangulation.number_of_vertices() - 2) * 3);
//	vec_data_degb3.reserve((triangulation.number_of_faces() + 1 + triangulation.number_of_vertices() - 2) * 4);
//	color_edge.reserve((triangulation.number_of_faces() + 1 + triangulation.number_of_vertices() - 2) * 2);
//	for (const std::pair<int, typename curve<Triangulation::Triangulation_base>>& p : triangulation.list_of_curve)
//	{
//		if (p.second.set_of_edge.size() == 0)
//			continue;
//		if (p.second.type == 1)
//		{
//			vec_data_degb1.emplace_back(p.second.p1.x / img_cols, p.second.p1.y / img_rows);
//			vec_data_degb1.emplace_back(p.second.p2.x / img_cols, p.second.p2.y / img_rows);
//		}
//		else if (p.second.type == 2)
//		{
//			vec_data_degb2.emplace_back(p.second.p1.x / img_cols, p.second.p1.y / img_rows);
//			vec_data_degb2.emplace_back(p.second.ctp1.x / img_cols, p.second.ctp1.y / img_rows);
//			vec_data_degb2.emplace_back(p.second.p2.x / img_cols, p.second.p2.y / img_rows);
//		}
//		else if (p.second.type == 3)
//		{
//			vec_data_degb3.emplace_back(p.second.p1.x / img_cols, p.second.p1.y / img_rows,
//				p.second.ctp1.x / img_cols, p.second.ctp1.y / img_rows);
//			vec_data_degb3.emplace_back(p.second.ctp2.x / img_cols, p.second.ctp2.y / img_rows,
//				p.second.p2.x / img_cols, p.second.p2.y / img_rows);
//		}
//	}
//	for (auto it(triangulation.finite_edges_begin()), it_end(triangulation.finite_edges_end()); it != it_end; ++it)
//	{
//		const auto& face = *it->first;
//		const int& idx = it->second;
//		const auto& p1 = face.vertex((idx + 1) % 3)->point();
//		const auto& p2 = face.vertex((idx + 2) % 3)->point();
//		vec_data_deg1.emplace_back(p1.x() / img_cols, p1.y() / img_rows);
//		vec_data_deg1.emplace_back(p2.x() / img_cols, p2.y() / img_rows);
//	
//#ifdef	USE_APPLICATION_CONTOURING
//			if (triangulation.face_data[it->first->info()].label
//				== triangulation.face_data[it->first->neighbor(it->second)->info()].label)
//				color_edge.emplace_back(0);
//			else
//				color_edge.emplace_back(1);
//#elif defined USE_APPLICATION_COMPRESSION
//		if (triangulation.vertex_data[get_vertex(*it, 1)->info()].color
//			== triangulation.vertex_data[get_vertex(*it, 2)->info()].color)
//			color_edge.emplace_back(0);
//		else
//			color_edge.emplace_back(1);
//#else
//		auto data_e = triangulation.edge_data[Mon_edge(it->first->vertex((it->second + 1) % 3)->info(), it->first->vertex((it->second + 2) % 3)->info())];
//		color_edge.emplace_back(data_e.label);
//#endif
//		color_edge.emplace_back(color_edge.back());
//	}
//	for (auto it(triangulation.finite_faces_begin()), it_end(triangulation.finite_faces_end()); it != it_end; ++it)
//	{
//		const typename Triangulation::Vertex_handle::value_type::Point& p1 = it->vertex(0)->point();
//		const typename Triangulation::Vertex_handle::value_type::Point& p2 = it->vertex(1)->point();
//		const typename Triangulation::Vertex_handle::value_type::Point& p3 = it->vertex(2)->point();
//		vec_data_triangle.emplace_back(p1.x() / img_cols, p1.y() / img_rows);
//		vec_data_triangle.emplace_back(p2.x() / img_cols, p2.y() / img_rows);
//		vec_data_triangle.emplace_back(p3.x() / img_cols, p3.y() / img_rows);
//		auto data_f = triangulation.face_data[it->info()];
//		
//#ifdef	USE_APPLICATION_CONTOURING
//
//		const glm::vec3& color = triangulation.face_data[it->info()].color;
//		color_triangle.emplace_back(color);
//		color_triangle.emplace_back(color);
//		color_triangle.emplace_back(color);
//
//#elif defined	USE_APPLICATION_COMPRESSION
//
//		color_triangle.emplace_back(triangulation.vertex_data[it->vertex(0)->info()].color);
//		color_triangle.emplace_back(triangulation.vertex_data[it->vertex(1)->info()].color);
//		color_triangle.emplace_back(triangulation.vertex_data[it->vertex(2)->info()].color);
//
//#endif
//	}
//	vbo_to_put_vertices.clear_vbo();
//	vbo_to_put_vertices.add_vertex(obj_name + "_0", vec_data_deg0);
//	vbo_to_put_vertices.add_vertex(obj_name + "_1", vec_data_deg1);
//	vbo_to_put_vertices.add_vertex(obj_name + "_b1", vec_data_degb1);
//	vbo_to_put_vertices.add_vertex(obj_name + "_b2", vec_data_degb2);
//	vbo_to_put_vertices.add_vertex(obj_name + "_b3", vec_data_degb3);
//	vbo_to_put_vertices.add_vertex(obj_name + "_1_c", color_edge);
//	vbo_to_put_vertices.add_vertex(obj_name + "_2", vec_data_triangle);
//	vbo_to_put_vertices.add_vertex(obj_name + "_2_c", color_triangle);
//	vbo_to_put_vertices.create_vbo();
//	
//#ifdef	USE_APPLICATION_CONTOURING 
//	auto* tri = ini_triangle_color(obj_name + "_2", vbo_to_put_vertices, depth, color_triangle.size());
//#elif defined	USE_APPLICATION_COMPRESSION
//	auto* tri = ini_triangle_color(obj_name + "_2", vbo_to_put_vertices, depth, color_triangle.size());
//#endif
//
//	gl_bezier_deg_color_1* edges = ini_bezier_deg_color<gl_bezier_deg_color_1>(obj_name + "_1", vbo_to_put_vertices, depth, color_edges, vec_data_deg1.size());
//	edges->line_width = 1.0f;
//#ifdef USE_LABEL_SKETCH_BE
//	gl_bezier_deg_1* b1 = ini_bezier_deg<gl_bezier_deg_1>(obj_name + "_b1", vbo_to_put_vertices, depth + 0.01, glm::vec3(0.0f,1.0f, 1.0f), vec_data_degb1.size());
//	b1->line_width = 2.0f;
//	b1->alpha = 1.0f;
//	gl_bezier_deg_2* b2 = ini_bezier_deg<gl_bezier_deg_2>(obj_name + "_b2", vbo_to_put_vertices, depth + 0.01, glm::vec3(1.0f, 1.0f, 0.0f), vec_data_degb2.size());
//	b2->line_width = 2.0f;
//	b2->alpha = 1.0f;
//	gl_bezier_deg_3* b3 = ini_bezier_deg<gl_bezier_deg_3>(obj_name + "_b3", vbo_to_put_vertices, depth + 0.01, glm::vec3(1.0f, 0.0f, 1.0f), vec_data_degb3.size());
//	b3->line_width = 2.0f;
//	b3->alpha = 1.0f;
//	std::cout << b1->nb_line / 2 << " " << b2->nb_line / 3 << " " << b3->nb_line / 2 << " " << triangulation.list_of_curve.size() << std::endl;
//	//std::cout << b2->nb_line / 3 << " " << b3->nb_line / 2 << " " << triangulation.list_of_curve.size() << std::endl;
//#endif
//
//#ifdef	USE_APPLICATION_CONTOURING 
//	return std::vector<float*>{&edges->alpha, &tri->alpha};
//#elif defined	USE_APPLICATION_COMPRESSION 
//	return std::vector<float*>{&edges->alpha, &tri->alpha};
//#else
//	return std::vector<float*>{&edges->alpha};
//#endif
//}

template<typename T>
Image_tex* gl_widget::ini_img(const cv::Mat_<T>& img, const std::string& obj_name, const float depth)
{
	Image_tex* ptr_point;
	auto a = obj_visibility.find(obj_name);
	if (a == obj_visibility.end())
	{
		ptr_point = (new Image_tex(
			new VAO(get_default_shader<Image_tex>(), vbo_img, { { "vertex", "vertex_images" },{ "tex", "tex_coord" } }), img));

		obj_visibility.emplace(std::make_pair(obj_name, std::pair<object*, bool>{ ptr_point, true }));
		ptr_point->depth = depth;
	}
	else
	{
		ptr_point = reinterpret_cast<Image_tex*>(a->second.first);
		ptr_point->texture->update_texture(img);
		a->second.second = true;
	}
	ptr_point->s = s;
	ptr_point->t = t;
	obj_2d.push_back(ptr_point);
	obj.push_back(ptr_point);
	return ptr_point;
}
#endif

