#pragma once

#include"util_define.h"

//#include "CImg.h"



	
extern float ZNEAR;//to redefine...
extern float ZFAR;//to redefine...

#include"MVSPoint.h"

class MVSPoint;

void convert_data(const std::vector< std::shared_ptr<MVSPoint> >& mvs_vec, std::vector<glm::vec3>& data);
//void save_data(const char* file, const std::vector<glm::vec3>& data);
//void load_data(const char* file, std::vector<glm::vec3>& data);
//void save_data(const char* file, const std::vector<float>& data);
//void load_data(const char* file, std::vector<float>& data);

template<typename T>
void _load(FILE* ptr_file, T& data)
{
	fread(&data, sizeof(T), 1, ptr_file);
}
template<typename T>
void _save(FILE* ptr_file, const T& data)
{
	fwrite(&data, sizeof(T), 1, ptr_file);
}

template<typename T>
inline void save_vector(FILE*& ptr_file, const std::vector<T>& data)
{
	const std::size_t size = data.size();
	fwrite(&size,sizeof(std::size_t),1,ptr_file);
	if(size)
		fwrite(&*data.begin(),sizeof(T),size,ptr_file);
}
template<typename T>
inline void load_vector(FILE*& ptr_file, std::vector<T>& data)
{
	std::size_t n;
	fread(&n,sizeof(std::size_t),1,ptr_file);
	data.resize(n);
	if(n)
		fread(&*data.begin(),sizeof(T),data.size(),ptr_file);
}
template<typename T>
void save_data(const char* file, const std::vector<T>& data)
{
	const std::size_t size = data.size();
	FILE* ptr_file = fopen(file,"wb");
	fwrite(&size,sizeof(std::size_t),1,ptr_file);
	if(size)
		fwrite(&*data.begin(),sizeof(T),size,ptr_file);
	fclose(ptr_file);
}
template<typename T>
void load_data(const char* file, std::vector<T>& data)
{
	std::size_t n;
	FILE* ptr_file = fopen(file,"rb");
	fread(&n,sizeof(std::size_t),1,ptr_file);
	data.resize(n);
	if(n)
		fread(&*data.begin(),sizeof(T),data.size(),ptr_file);
	fclose(ptr_file);
}
template<typename T, typename U>
inline void save_map(FILE*& ptr_file, const std::map<T,U>& data)
{
	const std::size_t size = data.size();
	fwrite(&size,sizeof(std::size_t),1,ptr_file);
	for(typename std::map<T,U>::const_iterator it(std::begin(data)),it_end(std::end(data));it!=it_end;++it)
	{
		fwrite(&(*it),sizeof(std::pair<T,U>),1,ptr_file);
	}
}
template<typename T, typename U>
inline void load_map(FILE*& ptr_file, std::map<T,U>& data)
{
	std::size_t n;
	fread(&n,sizeof(std::size_t),1,ptr_file);
	//data.resize(n);
	std::pair<T,U>* tmp = (std::pair<T,U>*) ::operator new(sizeof(std::pair<T,U>));
	for(std::size_t i=0; i!=n; ++i)
	{
		fread(tmp,sizeof(std::pair<T,U>),1,ptr_file);
		data.insert(data.end(),*tmp);
	}
	delete tmp;
}
template<typename T, typename U>
inline void save_map2(FILE*& ptr_file, const std::map<T,std::vector<U>>& data)
{
	const std::size_t size = data.size();
	fwrite(&size,sizeof(std::size_t),1,ptr_file);
	for(typename std::map<T,std::vector<U>>::const_iterator it(std::begin(data)),it_end(std::end(data));it!=it_end;++it)
	{
		fwrite(&it->first,sizeof(T),1,ptr_file);
		save_vector(ptr_file,it->second);
	}
}
template<typename T, typename U>
inline void load_map2(FILE*& ptr_file, std::map<T,std::vector<U>>& data)
{
	std::size_t n;
	fread(&n,sizeof(std::size_t),1,ptr_file);
	//data.resize(n);
	std::pair<T,std::vector<U>>* tmp = (std::pair<T,std::vector<U>>*) ::operator new(sizeof(std::pair<T,std::vector<U>>));
	new(&tmp->second)std::vector<U>;
	for(std::size_t i=0; i!=n; ++i)
	{
		fread(&tmp->first,sizeof(T),1,ptr_file);
		load_vector(ptr_file,tmp->second);
		data.insert(data.end(),*tmp);
	}
	delete tmp;
}
template<typename T, typename U>
inline void save_map_set(FILE*& ptr_file, const std::map<T, std::set<U>>& data)
{
	const std::size_t size = data.size();
	fwrite(&size, sizeof(std::size_t), 1, ptr_file);
	for (typename std::map<T, std::set<U>>::const_iterator it(std::begin(data)), it_end(std::end(data)); it != it_end; ++it)
	{
		fwrite(&it->first, sizeof(T), 1, ptr_file);
		save_set(ptr_file, it->second);
	}
}
template<typename T, typename U>
inline void load_map_set(FILE*& ptr_file, std::map<T, std::set<U>>& data)
{
	std::size_t n;
	fread(&n, sizeof(std::size_t), 1, ptr_file);
	//data.resize(n);
	std::pair<T, std::set<U>>* tmp = (std::pair<T, std::set<U>>*) ::operator new(sizeof(std::pair<T, std::set<U>>));
	new(&tmp->second)std::set<U>;
	for (std::size_t i = 0; i != n; ++i)
	{
		fread(&tmp->first, sizeof(T), 1, ptr_file);
		load_set(ptr_file, tmp->second);
		data.insert(data.end(), *tmp);
		tmp->second.clear();
	}
	delete tmp;
}
template<typename T, typename U>
inline void save_map_list(FILE*& ptr_file, const std::map<T, std::list<U>>& data)
{
	const std::size_t size = data.size();
	fwrite(&size, sizeof(std::size_t), 1, ptr_file);
	for (typename std::map<T, std::list<U>>::const_iterator it(std::begin(data)), it_end(std::end(data)); it != it_end; ++it)
	{
		fwrite(&it->first, sizeof(T), 1, ptr_file);
		save_list(ptr_file, it->second);
	}
}
template<typename T, typename U>
inline void load_map_list(FILE*& ptr_file, std::map<T, std::list<U>>& data)
{
	std::size_t n;
	fread(&n, sizeof(std::size_t), 1, ptr_file);
	//data.resize(n);
	std::pair<T, std::list<U>>* tmp = (std::pair<T, std::list<U>>*) ::operator new(sizeof(std::pair<T, std::list<U>>));
	new(&tmp->second)std::list<U>;
	for (std::size_t i = 0; i != n; ++i)
	{
		fread(&tmp->first, sizeof(T), 1, ptr_file);
		load_list(ptr_file, tmp->second);
		data.insert(data.end(), *tmp);
		tmp->second.clear();
	}
	delete tmp;
}
//template<typename T, typename... Args>
//inline void save_collection(FILE*& ptr_file, const T<Args...>& data)
//{
//}
template<typename T>
inline void save_set(FILE*& ptr_file, const std::set<T>& data)
{
	const std::size_t size = data.size();
	fwrite(&size,sizeof(std::size_t),1,ptr_file);
//std::cout << size << std::endl;
	for(typename std::set<T>::const_iterator it(std::begin(data)),it_end(std::end(data));
		it!=it_end;++it)
	{
		fwrite(&(*it),sizeof(T),1,ptr_file);
	}
}
template<typename T>
inline void load_set(FILE*& ptr_file, std::set<T>& data)
{	std::size_t n;
	fread(&n,sizeof(std::size_t),1,ptr_file);
	T* tmp = (T*) ::operator new(sizeof(T));
	for(std::size_t i=0; i!=n; ++i)
	{
		fread(tmp,sizeof(T),1,ptr_file);
		data.insert(data.end(),*tmp);
	}
	delete tmp;
}
template<typename T>
inline void save_list(FILE*& ptr_file, const std::list<T>& data)
{
	const std::size_t size = data.size();
	fwrite(&size, sizeof(std::size_t), 1, ptr_file);
	//std::cout << size << std::endl;
	for (typename std::list<T>::const_iterator it(std::begin(data)), it_end(std::end(data));
		it != it_end; ++it)
	{
		fwrite(&(*it), sizeof(T), 1, ptr_file);
	}
}
template<typename T>
inline void load_list(FILE*& ptr_file, std::list<T>& data)
{
	std::size_t n;
	fread(&n, sizeof(std::size_t), 1, ptr_file);
	T* tmp = (T*) ::operator new(sizeof(T));
	for (std::size_t i = 0; i != n; ++i)
	{
		fread(tmp, sizeof(T), 1, ptr_file);
		data.insert(data.end(), *tmp);
	}
	delete tmp;
}
template<typename T>
inline void save_vector_set(FILE*& ptr_file, const std::vector<std::set<T>>& data)
{
	const std::size_t size = data.size();
	fwrite(&size,sizeof(std::size_t),1,ptr_file);
	for(typename std::vector<std::set<T>>::const_iterator it(std::begin(data)),it_end(std::end(data));
		it!=it_end;++it)
	{
		save_set(ptr_file,*it);
	}
}
template<typename T>
inline void load_vector_set(FILE*& ptr_file, std::vector<std::set<T>>& data)
{
	std::size_t n;
	fread(&n,sizeof(std::size_t),1,ptr_file);
	data.resize(n);
	for(typename std::vector<std::set<T>>::iterator it(std::begin(data)),it_end(std::end(data));
		it!=it_end;++it)
	{
		load_set(ptr_file,*it);
	}
}
template<typename T>
inline void save_vector2(FILE*& ptr_file, const std::vector<std::vector<T>>& data)
{
	const std::size_t size = data.size();
	fwrite(&size,sizeof(std::size_t),1,ptr_file);
	for(typename std::vector<std::vector<T>>::const_iterator it(std::begin(data)),it_end(std::end(data));
		it!=it_end;++it)
	{
		save_vector(ptr_file,*it);
	}
}
template<typename T>
inline void load_vector2(FILE*& ptr_file, std::vector<std::vector<T>>& data)
{
	std::size_t n;
	fread(&n,sizeof(std::size_t),1,ptr_file);
	data.resize(n);
	for(typename std::vector<std::vector<T>>::iterator it(std::begin(data)),it_end(std::end(data));
		it!=it_end;++it)
	{
		load_vector(ptr_file,*it);
	}
}
//void save_augmented_data(const char* file, const AugmentedMesh& data);
//void load_augmented_data(const char* file, AugmentedMesh& data);


