#pragma once
#ifndef __HEADER_UTIL_FOR_CGAL__
#define __HEADER_UTIL_FOR_CGAL__


struct Mon_edge
{
	static_assert(sizeof(std::size_t) >= 2 * sizeof(int), "bad size type: compile in 64bit or replace std::size_t by any type of at least 64 bit (like double)");
	std::size_t id_edge;
	Mon_edge(int i, int j)
	{
		if (i < j)
		{
			((int*)&id_edge)[0] = i;
			((int*)&id_edge)[1] = j;
		}
		else
		{
			((int*)&id_edge)[0] = j;
			((int*)&id_edge)[1] = i;
		}
	}
	operator std::size_t&() { return id_edge; }
	operator const std::size_t&()const { return id_edge; }
};
template<typename Edge>
typename const Edge::first_type::value_type::Vertex_handle get_vertex(const Edge& e, int i)
{
	return e.first->vertex((e.second + i) % 3);
}
template<typename Edge>
typename Edge::first_type::value_type::Vertex_handle get_vertex(Edge& e, int i)
{
	return e.first->vertex((e.second + i) % 3);
}
template<typename Edge>
typename Mon_edge get_mon_edge(const Edge& e)
{
	return Mon_edge(get_vertex(e,1)->info(), get_vertex(e,2)->info());
}
//template<typename Edge>
//std::pair<const typename Edge::first_type::value_type::Vertex*, const typename Edge::first_type::value_type::Vertex*>
//	edge_to_pair_vertices(const Edge& e)
//{
//	return{&*get_vertex(e, 1), &*get_vertex(e, 2)};
//}

/*


Elem_around(const Circulator& c) : circ(c), circ_end(c)

do
{
	f(*c)
}while(++c!=c_end);



*/


template<typename Circulator, typename Fn>
void elem_around(Circulator c, Fn fn)
{
	Circulator c_end = c;
	do
	{
		fn(*c);
	} while (++c != c_end);
}
template<typename Circulator, typename Fn>
void elem_around_ptr(Circulator c, Fn fn)
{
	Circulator c_end = c;
	do
	{
		fn(c);
	} while (++c != c_end);
}
template<typename Circulator, typename Fn>
bool elem_around_break(Circulator c, Fn fn)
{
	Circulator c_end = c;
	do
	{
		if (fn(*c))
			return true;
	} while (++c != c_end);
	return false;
}

//
//template<typename Circulator>
//struct Elem_around
//{
//	bool first;
//	Circulator circ;
//	const Circulator circ_end;
//
//	Elem_around(const Circulator& c) : circ(c), circ_end(c), first(true) {}
//	Elem_around(const Circulator& c, const Circulator& c_end, const bool& is_first) : circ(c), circ_end(c_end), first(is_first) {}
//	Elem_around(const Elem_around<Circulator>& ea): circ(ea.circ), circ_end(ea.circ_end), first(ea.first) {}
//
//	Elem_around<Circulator> begin()
//	{
//		return *this;
//	}
//	Elem_around<Circulator> end()
//	{
//		return Elem_around<Circulator>(circ_end, circ_end, false);
//	}
//	Elem_around<Circulator>& operator++()
//	{
//		++circ;
//		if(first)
//			first = false;
//		return *this;
//	}
//	Elem_around<Circulator> operator++(int)
//	{
//		Elem_around<Circulator> tmp(*this);
//		if (first)
//			first = false;
//		++circ;
//		return tmp;
//	}
//	const decltype(*circ)& operator*() const
//	{
//		return *circ;
//	}
//	const decltype(&*circ) operator->() const
//	{
//		return &*circ;
//	}
//	decltype(*circ)& operator*()
//	{
//		return *circ;
//	}
//	decltype(&*circ) operator->()
//	{
//		return &*circ;
//	}
//	bool operator==(const Elem_around<Circulator>& c)const
//	{
//		return first == c.first && circ == c.circ && circ_end == c.circ_end;
//	}
//	bool operator!=(const Elem_around<Circulator>& c)const
//	{
//		return first != c.first || circ != c.circ || circ_end != c.circ_end;
//	}
//};
//template<typename Circulator>
//Elem_around<Circulator> elem_around(const Circulator& c)
//{
//	return Elem_around<Circulator>(c);
//}

#endif
