
#include "gl_widget.h"
//#include"texture_sfml.hpp"
//#include"texture_qt.h"
#include"get_color_from_gray.h"
#include"image_tex.h"
#include <QFileDialog>
#include<QtGui/QImage>
#include"save_file.h"
#include"save_svg.h"

gl_widget* q_slider_change_alpha::mon_gl_widget = nullptr;


gl_widget::~gl_widget()
{
	obj.clear();
	obj_2d.clear();
	for (auto& a : obj_visibility)
		delete a.second.first;
	obj_visibility.clear();
	object::map_type_shader.clear();
	//fc_ini.clear();
}
gl_widget::gl_widget(QWidget *parent)
	:QGLWidget(QGLFormat(QGL::DoubleBuffer | QGL::DepthBuffer), parent), fbo(), s(0.5f), s_den(2), t(0.0f, 0.0f),
	vbo(GL_ARRAY_BUFFER, GL_DYNAMIC_DRAW), vbo_img(GL_ARRAY_BUFFER, GL_DYNAMIC_DRAW),// vbo_bezier_1_1(GL_ARRAY_BUFFER), vbo_bezier_2_2(GL_ARRAY_BUFFER), vbo_bezier_3_1(GL_ARRAY_BUFFER, GL_DYNAMIC_DRAW), vbo_bezier_selected(GL_ARRAY_BUFFER, GL_DYNAMIC_DRAW),//, ibo(GL_ELEMENT_ARRAY_BUFFER), ibo_sketch(GL_ELEMENT_ARRAY_BUFFER), vbo_line(GL_ARRAY_BUFFER, GL_DYNAMIC_DRAW), vbo_lien_sol(GL_ARRAY_BUFFER, GL_DYNAMIC_DRAW), timer(new QTimer(this)),
	ratio(1.0f)
{
	img_cols = width();
	img_rows = height();
	w=h=0;
	setMouseTracking(true);
    this->translate(0, 0, -4);
    this->translate(0, 0, -12);
    this->rotate(M_PI/6, 1, 0, 0);

    this->rotate(-M_PI/6, 0, 1, 0);
    this->rotate(0, 0, 0, 1);
		real_size.x=width();
		real_size.y=height();
		scale_size.x=1.0f;
		scale_size.y=1.0f;


}

void gl_widget::update()
{
    updateGL();
}
template<typename T>
T* gl_widget::ini_bezier_deg(const std::string& obj_name, VBO& vbo_to_put_vertices, const float depth, const glm::vec3& color, const std::size_t& deg)
{
	T* ptr_point;
	auto a = obj_visibility.find(obj_name);
	if (a == obj_visibility.end())
	{
		ptr_point = new T(
			new VAO(get_default_shader<T>(), vbo_to_put_vertices, { { "ct_pt", obj_name } }), GLsizei(deg), depth, color);
		obj_visibility.emplace(std::make_pair(obj_name, std::pair<object*, bool>{ ptr_point, true }));
	}
	else
	{
		ptr_point = reinterpret_cast<T*>(a->second.first);
		ptr_point->get_vao()->re_link_vao();
		a->second.second = true;
		ptr_point->nb_line = (int)deg;
	}
	ptr_point->s = s;
	ptr_point->t = t;
	if (!::find(dynamic_cast<repere_2d*>(ptr_point), obj_2d))
	{
		obj_2d.push_back(ptr_point);
		obj.push_back(ptr_point);
	}
	return ptr_point;
}
gl_triangle_color* gl_widget::ini_triangle_color(const std::string& obj_name, VBO& vbo_to_put_vertices, const float depth, const std::size_t& deg)
{
	gl_triangle_color* ptr_point;
	auto a = obj_visibility.find(obj_name);
	if (a == obj_visibility.end())
	{
		std::cout << "creation " << obj_visibility.size() << std::endl;
		ptr_point = new gl_triangle_color(
			new VAO(get_default_shader<gl_triangle_color>(), vbo_to_put_vertices, { { "ct_pt", obj_name },{ "color", obj_name + "_c" } }), GLsizei(deg), depth);
		obj_visibility.emplace(std::make_pair(obj_name, std::pair<object*, bool>{ ptr_point, true }));
	}
	else
	{
		ptr_point = reinterpret_cast<gl_triangle_color*>(a->second.first);
		ptr_point->get_vao()->re_link_vao();
		a->second.second = true;
		ptr_point->nb_line = (int)deg;
	}
	ptr_point->s = s;
	ptr_point->t = t;
	ptr_point->alpha = 0.5f;
	if (!::find(dynamic_cast<repere_2d*>(ptr_point), obj_2d))
	{
		obj_2d.push_back(ptr_point);
		obj.push_back(ptr_point);
	}
	return ptr_point;
}
template<typename T>
T* gl_widget::ini_bezier_deg_color(const std::string& obj_name, VBO& vbo_to_put_vertices, const float depth, const std::vector<glm::vec3>& color, const std::size_t& deg)
{
	T* ptr_point;
	auto a = obj_visibility.find(obj_name);
	if (a == obj_visibility.end())
	{
		ptr_point = (new T(
			new VAO(get_default_shader<T>(), vbo_to_put_vertices, { { "ct_pt", obj_name },{ "color_hint", obj_name + "_c" } }), GLsizei(deg), depth, color));
		obj_visibility.emplace(std::make_pair(obj_name, std::pair<object*, bool>{ ptr_point, true }));
	}
	else
	{
		ptr_point = reinterpret_cast<T*>(a->second.first);
		ptr_point->get_vao()->re_link_vao();
		a->second.second = true;
		ptr_point->nb_line = (int)deg;
	}
	ptr_point->s = s;
	ptr_point->t = t;
	if (!::find(dynamic_cast<repere_2d*>(ptr_point), obj_2d))
	{
		obj_2d.push_back(ptr_point);
		obj.push_back(ptr_point);
	}
	return ptr_point;
}
template gl_bezier_deg_color_1* gl_widget::ini_bezier_deg_color<gl_bezier_deg_color_1>(const std::string&, VBO&, const float, const std::vector<glm::vec3>&, const std::size_t&);


void gl_widget::set_input_img(const cv::Mat_<cv::Vec3f>& img)
{
	const cv::Mat_<cv::Vec3f> img_tmp = 255.0f * img;
	v_change_alpha_event[0]->_connect(&ini_img(img_tmp, "input_image", 0.9f)->alpha);
	img_rows = img.rows;
	img_cols = img.cols;
	resizeGL(this->width(), this->height());
	update();
}

