#include"gl_widget.h"

void gl_widget::initializeGL()
{
	std::cout << "ini gl" << std::endl;
    QString str;
	real_size.x=width();
	real_size.y=height();
	m_width=width();
	m_height=height();

	if (glewInit() != GLEW_OK)
	{
		std::cout << "glewInit failed, aborting." << std::endl;
	}


	glClearColor(1.0f, 1.0f, 1.0f, 0.0f);
    //glShadeModel(GL_FLAT);
    glShadeModel(GL_SMOOTH);


   glEnable(GL_DEPTH_TEST);
   glEnable (GL_BLEND);
  // glEnable(GL_LINE_SMOOTH);
   glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
  // glBlendFunc(GL_ONE, GL_ONE_MINUS_SRC_ALPHA);
 //  glHint(GL_LINE_SMOOTH_HINT, GL_DONT_CARE);

    glEnable( GL_TEXTURE_2D );

//	glBlendFunc(GL_ONE, GL_ONE);
	fbo.ini();
	fbo.add_texture("color",std::shared_ptr<Texture>(new Texture(real_size)),GL_COLOR_ATTACHMENT0);
	std::shared_ptr<RenderBuffer> render_buffer_tmp(new RenderBuffer(GL_DEPTH_COMPONENT24,real_size,GL_DEPTH_ATTACHMENT));
	render_buffer_tmp->ini();
	fbo.add_texture("depth",render_buffer_tmp);
	fbo.add_attachment(GL_COLOR_ATTACHMENT0, GL_DEPTH_ATTACHMENT);
	Shader::disable();
	//FBO::disable();
	VBO::disable();
	VAO::disable();
	fbo.disable();

	const glm::vec3 A(-1, -1, 0), B(1, -1, 0), C(1, 1, 0), D(-1, 1, 0);
	//const glm::vec3 A(0, 0, 0), B(1, 0, 0), C(1, 1, 0), D(0, 1, 0);
	std::vector<glm::vec3> vec3_data = { A, B, C, D };
	const glm::vec2 tex_00(0, 0), tex_10(1, 0), tex_01(0, 1), tex_11(1, 1);
	std::vector<glm::vec2> vec2_data = { tex_00, tex_10, tex_11, tex_01 };

	vbo_img.clear_vbo();
	vbo_img.add_vertex("vertex_images", vec3_data);
	vbo_img.add_vertex("tex_coord", vec2_data);
	vbo_img.create_vbo();

	update();
	//connect(timer, SIGNAL(timeout()), this, SLOT(update()));
    //timer->start(50.0/3);
}
void gl_widget::sub_draw(const glm::mat4& scene)
{
	GLfloat x;
	glm::mat4 m, proj;
	float focal(M_PI / 6);
	if (w != 0)
	{
		x = w / h;
		focal = 2.0 * atan(0.5* h / coeff_focal);

	}
	else
		x = GLfloat(m_width) / m_height;

	proj = glm::perspective(focal, x, 0.1f, 1000.0f);
	m = scene*repere_origin::get_repere();

	m = proj*m;
	for (object* const& o : obj)
	{
		o->draw(m);
	}
}
void gl_widget::paintGL()
{
	fbo.enable_to_render();
	fbo.bind_for_draw();
	fbo.attach_texture("color");
	fbo.attach_render_buffer("depth");
	fbo.check();
//	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	sub_draw(glm::mat4());


	fbo.disable();
	fbo.enable_to_read(GL_COLOR_ATTACHMENT0);
	fbo.attach_texture("color");
	
			glBlitFramebuffer(0,0,width(), height(),
				0, 0, width(), height(),//real_size.x,real_size.y,
							  GL_COLOR_BUFFER_BIT, GL_LINEAR);
	fbo.disable();
	//text.draw(this);

}
void gl_widget::resizeGL(int width, int height)
{
	ratio = img_cols*1.0 / img_rows;
	if (height*ratio > width)
	{
		viewport = glm::vec4((width - height*ratio) / 2, 0, height*ratio, height);
		real_size.x = height*ratio;
		real_size.y = height;
	}
	else
	{
		viewport = glm::vec4(0, (height - width / ratio) / 2, width, width / ratio);
		real_size.x = width;
		real_size.y = width / ratio;
	}
	glViewport(viewport.x, viewport.y, viewport.z, viewport.w);
	m_width = width;
	m_height = height;
	scale_size.x = width / real_size.x;
	scale_size.y = height / real_size.y;

	fbo.resize(width, height);
	//update();
}
